local TailsKK = {version = "0.6.9.1 PUBLIC BETA", --i swear this wasn't intentional, the version numbers just lined up
            versiontable = {0, 6, 9, 1}}

TailsKK.attributions = {
{"EeveeEuphoria/Ibly", "Creator"},
{"Varren/sprkizard", "l_fontlib.lua for SRB2"},
{"int10h.org", "Nixdorf 8810 M15 font"},
{"amperbee", "Advice and help from the Kart Krew Dev & SRB2 discord guilds"},
{"Princess Fluffles", "Playtester"},
{"ChrisFurry", "Logo for this mod. \x82Website\x80: chrisfurry.github.io"},
{"kiophen", "3D Sega Saturn render used for promotional material. \x82Website\x80: mileshouse.neocities.org"}
}

--[[
                 _____      _ _     _
                /__   \__ _(_) |___( )
                  / /\/ _` | | / __|/
                 / / | (_| | | \__ \
                 \/_  \__,_|_|_|___/
              /\ /\ |__   __ _  ___  ___
             / //_/ '_ \ / _` |/ _ \/ __|
            / __ \| | | | (_| | (_) \__ \
            \/  \/|_|_|_|\__,_|\___/|___/_   _
     /\ /\___  _ __ | |_ _ __ __ _ _ __ | |_(_) ___  _ __
    / //_/ _ \| '_ \| __| '__/ _` | '_ \| __| |/ _ \| '_ \
   / __ \ (_) | | | | |_| | | (_| | |_) | |_| | (_) | | | |
   \/  \/\___/|_| |_|\__|_|  \__,_| .__/ \__|_|\___/|_| |_|
                                  |_|

This is a from-the-ground-up rewrite of the chaos script, originally made for SRB2 (SRB2: Chaotic Edition) and SRB2Kart (SRB2Khaos).
I've made this to allow for mod support (see TKK-Mod-Example-lua.txt), and cleaned up a lot of the sloppy code I made from years ago. I've overhauled how effects are applied, the HUD system, and the settings system to be more reliable, readable, and generally more netgame-safe. This is an overall improvement I hope, and should be the basis for my chaos mods for more years to come.
]]

--[[ !! Reusability Notice !!

    - This mod is marked as reusable, meaning you can take this mod and modify it any way you want.
        - However, do consider that this mod can be extendable for you to add your own effects! I'd recommend going that avenue first.
    - Any elements found in this mod are reusable, assuming credit is given to appropriate authors if it's not my work. This includes the two fonts utilized with this mod.

]]


--[[BUG FIXES:

    - [ ] Universal Effect sounds can't be heard by spectators, I'll need to readjust my code to account for that.

    - [ ] Insta-Item sometimes leaves behind item boxes when on a dedicated server.
        - Solution: Convert insta-item into a khaos effect that gets applied to the player.
            - This also allows me to give the player an item when their roulette is cleared, and once their distance check is valid. Latter should be removed once they fix that one bug.

    - [ ] If you die with a text box, you just get stuck.
        - Still seems to happen, despite detecting for player respawn.
            - Just reset everything in the text box values, or remove itself.
    - [ ] Sometimes the pizza doesn't hit the player. Might have something to do with my new code, or it being re-applied?
    - [?] Bots seem to exist during the egg prisons game in grand prix. Don't run this code on them!
        - [?] Detect for bots inside GT_RACE, if not that, then skip.
    - [?] DO NOT RUN IF PLAYER IS SPECTATOR
        - [x] fix up the code, make this a function

    - [?] Fix effects that do stuff like "value.timer % 5", they're broken when respawning.
        - Done, it seems to work, but needs further testing.

    - [ ] Investigate what happens if someone finishes the race in the middle of a Universal Effect being rolled for, that might be a bug waiting to happen.

    - [x] Disable "zero gravity" when respawning.
    - [x] Fix "overreaction"
        - The player can enter a stun loop, which just freezes them in place forever.
        - [?] Have some kind of cool down.
        - [x] Test on CD Special Stage 8, ontop of those wall bumper things. That reliably causes the glitch.
    - [x] Add failsafe if the player has been respawning for more than 5 seconds.
        - [x] Check for player.respawn.state, and start a timer. If player isn't respawning, reset the timer to 0 seconds.
        - [x] If greater than 5 seconds, then the timer should keep ticking.
            - [x] If greater than 7 seconds, double the speed of the timer to get rid of effects

]]

--[[ Before Playtest releases:
    - [x] Test to see if the new property I added to "Wacky Textures" works properly.
    - [x] Add "PUBLIC PLAYTEST" to the version string
    - [x] Check if "Double Items" still works, I changed the duration to -1.
    - [ ] Triple check the HUDPosition code that checks for spectators/replay viewers.
        - It shouldn't cause desysncs, but I have no idea.
        - If it does, move all related ytime code to the HUD.
    - [ ] Comment out all debug features, search "TODO" and "DEBUG"
    - [x] Add in the mod test lua to the PK3, but turn it into a txt so the game doesn't run it.
        - Try to document how to add Universal Effects... if that's even a thing that's possible.

]]

--[[ NOTICE: IMPORTANT TODO BEFORE RELEASE:
    - Test the podium sequence, can you soft lock it?
        - Make a script that freezes all players in place during that sequence, based on the map title.
        - Then see if I can skip it, which just fast forwards the cutscene.
        - If this doesn't work, have a failsafe where the script forcibly removes all effects after a player gets stuck for 30 seconds.
        - Also, make certain effects not play during the podium sequence.
    - Add an important notice to the forum post, telling people if they use dedicated servers, to add the file *after* start up.
    - REMOVE DEBUG TOOLS, SEARCH ALL TODO ITEMS
    - ALSO CTRL+F SEARCH FOR "PRINT", REPLACE IT ALL WITH CONSOLE PRINTS, OR REMOVE THEM ALTOGETHER. OR COMMENT THEM OUT IDGAF
    - Implement the blacklist functionality, if I haven't already.
    - Test Sealed Stars! It's unknown how the effects here impact this.
    - Do a full couple of rounds with Grand Prix, just to see how it all functions.
        - This will also test Egg Prisons.
    - Create a video that shows off all the effects this mod has to offer, and explanations for their effects.
    - Replace all "KH_PLACEHOLDER" icons that currently exist.
]]


--[[ Effects to do:
missing from chaotic edition: (marked with [p] means it's in the previous version of this script)
    - No Abilities
            - Import from SRB2Khaos
            - It's just "No Drifting" there
            - Also disable the use of items and rings here
    - [p] Spawn Object
        - When spawning an object, if it's an item that hits a player, use: mobj.target = player.mo
    - Negative Rings
        - Seems to consistently cause a crash a little bit after it's applied. Maybe it's the sound? Or the way I replaced the rings object?
    - Ghost
        - Maybe just have this instantly apply what happens when you get ghosted in the game?
    - Give Good Stuff
        - Kartstuff doesn't exist :(
            -   player.itemtype = KITEM_INVINCIBILITY
                player.itemamount = 1
    - [p] Money Bag
        - Make this bluespheres in battle mode, if that isn't already the case
    - Black Hole
        - Turn this into a universal effect, someone random gets this.
            - Call it "The Most Attractive Racer"
        - Rare universal effect at that.
    - Busted Controller
    - [p] 2x Rings
    - [p] Sticky Slopes
    - [p] Bleeding
    - PRESS X OR GET HIT
        - Rename this to "Simon Says", because that's just silly. And make the gimmick be see if simon says, y'know.
        - Just make it use a combo of keys the player has access to.
            - Make it Brake, Accelerate, Drift, and Item.
            - Also make the text bigger.

Exclusive Effects:
    - Cement Tires (technically)
    - Hop!
    - Timebomb
    - No Turning
    - Insta-Boost
    - Hey! Listen!
    - Quicksand!
    - Laggy Model
    - Kids These Days
    - Overreaction

Effects to import and fix:
    - [?] Fix "the ride never ends"
        - This one actually works, but it doesn't tilt the player's sprite. Maybe needs to be done in postthink.
]]


--[[ FX Ideas
    - Water Walker
        - does what is says on the tin

    - Wacky Item Roulette
        - Next item roulette the player gets, will have stupid busted items.
        - Have a table with all the possible sets.
        - ...also figure out how the roulette is set up internally.

    - Calm and Collected
        - Opposite of "Overreaction", no hit lag, and damage deals a lot less knockback.
        - Maybe just merge this with Lucky.

    - Instantly Use Item
        - Makes you instantly use your item, whether you want to or not.
        - Effect runs for a small amount of time just to do it's stuff.
            - Make a list of items you drag behind yourself.
            - Then, have it randomly do up and down inputs for every item amount you have. (just check for item amount > 0 )
        - Also make it stop item roulettes too.
            - Make it play that sound from SRB2kart when you interrupted the roulette early.

    - Trap Rain
        - Universal effect, it rains trap items on the course
        - Maybe use map checkpoints, and spawn items around said checkpoints.
            - What object is used for checkpoints?

    - Super Explosive 64
        - sprite: KH_EXPLODE
        - Collisions with anything causes explosions
            - Force iframes off for each explosion, just to be funny.
            - Detect wall bumps
            - And player collisions
            - Rings and item boxes explode too
                - Make them break and disappear when that happens, but don't give the player anything from them
                - Instantly take away the item roulette from the player, and the player just loses rings anyways.
        - Don't use the landmine explosion for this, find something else maybe

    - Bullet Time
        - This just slows down the player compared to everyone else. All actions are slower.
        - Would be a bitch to do though, I'd need to slow down *all* the animations somehow.

    - Press Z to Crunch
        - Press the fast fall button and it squishes the player, causing damage
        - Make a squish animation

    - Randomized Sounds
        - Re-do this from the ground up
        - Or just look at this again? I used it for MMT, so...
            - https://mb.srb2.org/addons/personal-sounds.2924/
        - Sound functions are local to the player only, avoid trying to base too much code off that.
            - Have it cycle through a list of sounds, if it detects a sound, it just reads the current cycle and replaces that sound.
            - Maybe have the table randomized on start, but other than that, that should work. Other players probably won't hear the same sounds, but oh well

    - The Wheels Of Fate
        - Universal effect that applies to everyone.
        - This spins up 3 slots that will give the player certain minor attributes.
            - This can be giving rings, taking away rings, buffed speed, or certain items.
        - Use the same roulette noises as the one from the Egg Dealer in shadow the hedgehog
            - Noise lasts 89.6 tics, play the loop after that, which lasts 23.5 tics.

    - Position Swap
        - Use "sfx_mixup" when the position swap occurs.
        - Do it in a way where nobody goes more than 1 position ahead/behind.
            - 1 and 2 swap places, 3 and 4 swap places, etc.

]]

--[[ Effects 2 Fix:

    - Wacky Textures
        - Add exceptions to the sneaker pads and super sneaker pads or whatever they're called.
            - And tripwires.

]]


--[[ FEATURES TO ADD:

    - Make the replay use random sounds for universal effects.
        - Have it call the random function *before* the checks, that way random numbers don't get out of sync.

    - Randomize the position of the DVD logo on start.
        - Also randomize if it goes up, down, left, right, etc.

    - Restore the player's character and color on mapchange.
        - Maybe refer to their console variables?

    - "tkkWhatIs", a command that tells you about certain effects.
        - Add a description to effects.
        - Also show "sorry nothing :(" if no description exists.

    - Border behind the text
        - Look to that WIP combi mod for inspiration:
        - https://git.do.srb2.org/KartKrew/RingRacers/-/merge_requests/39
        - I think the logic is simple, just draw something behind every character, then at the start and end have a special decoration.
            - First start with the... start, have a negative offest by the first character. Then do each character, no offset. Then, after the final character, have a positive offset.
            - Also, render this first, then the characters, cuz render priority.

    - Have mods that interface with this require that they specify what mod they are
        - Can do stuff with this later, just make this a requirement.
        - Also, make all internal effects use "base" as the set mod.
            - Stop mods from using "base" as it's mod.

    - Make respawns faster somehow.
        - Setting player.mo.hitlag = 0 every frame makes it so the player instantly respawns from a death.

    - Randomize Followers

    - Make Followers make sounds at random

    - Make the scale of mines bigger for nuke

    - Remove all effects when player has finished the race
        - Run the remove function

    - Re-add "no special stage" and remove some of the more frustrating effects to make special stages actually completable.
        - It still needs to be chaos, but it shouldn't make it out of the question.

    - Make the timer bars glow a little bit when they are about to reach the end.
        - It'd be like, the last 80% of the bar.
        - Unable to do this for the rainbow bar, but whatever.

    - Have "Wacky Textures" have a chance to instead swap around all the textures on a course.
        - Would make things more visually interesting.

    - Make Nuke be a 1/2 chance to not prevent the hit in amplify mode

    - Completely overhaul the icons in the HUD.
        - No idea how to do this, think of ideas.

    - On "Superring", have it add ring boost.
        - Figure out the code for this and add the appropriate amount

    - Restore the player-table roulette system to discard incompatible effects
        - Faster rolls can be done like this.
        - Only store numbers to make sure things stay quick and simple.
        - Fall back on the original table if the player table doesn't currently exist.

    - Add text boxes that references 5secondfilms

    - Look through the ghostmobj function to see everything that needs to be copied over
        - I don't know what "standingslope" is but it doesn't seem to like being set directly.

    - Rework the HUD.
        - Experiment: Offset all the graphics to have their offsets at the center. Does that make any of the math easier to do?

    - Change up the SFX for a lot of effects.
        - Make "Moonjump" play a sound when the key combo is pressed.

    - Have "nuke" still affect you if someone else got it at the same time as you.
        - Makes rolling for it in "you get the bees" more chaotic.
        - If you get hit by something that has you as the target, then ignore the damage. Else, continue on with mobjdamage (return false?)

    - Make dodging a hit with "Lucky!" play the Lucky sound from Paper Mario, and use the text from there too.
        - Might be a bit much actually, considering the sound...

    - Add the blacklist feature.
        - Have exceptions to it like "Roulette" to stop any jank shit from happening.
        - Also, don't have this work on "you get the bees"?
        - Use the "KhaosNamesOnlyTable" table.
            - Make it cvar compatible, somehow.
        - More jank time: Make it a cvar, and do the usual set up. Every time the cvar changes in the menu, it will change the player's variable.
            - But it won't add that option to the blacklist. Instead, that sets it up. The player has to run a command after that to append it to the blacklist table.
            - Though, also make that command allow you to straight-up add the effect to the black-list, instead of having to do cvar shenanigans.
        - Also have a command that resets the blacklist. Require it to be ran twice, by setting a 5 second timer in the player, that if above 0, will count as the second press.

    - Add the "destroyed kart" sprite to change sprite.

    - "the pizza is aggressive" should use mapobjectscale instead of FRACUNIT.

    - [?] Have the text box show the button prompt for accelerate.
        - [ ] Uncomment this and fix the position, maybe change up the text box UI to accomodate for the button.

    - Maybe come up with a different name for "Universal Effects", one that's more fitting when there's just 1 player.
        - Would make it more convienent when I backport all this back into SRB2 Chaotic Edition

    - Have effects that would apply multiple times instead just add to the timer.
        - Include exceptions of course, or do the inverse and make it a "add2timer" variable.
        - In the non-conflict check, make it pass the already exists thing if it plans to add to the timer.
            - And then, on ApplyEffect, check for the conditions, and instead find that effect to apply the additional timer to. Make the HUD say "Extended timer for $EFFECT"

    - Have effects remove themselves if the player is currently respawning.
        - Detect for this, and remove accordingly.
            - Though also try to detect for if the player *manually* initiates that...

    - Don't apply universal effects for players who have already passed the finish line

    - [?] Now that everything is stored in a global table variable... allow mods to interface with this. As in, add effects.
        - [?] Have a seperate "addEffect" function, that works to facilitate mods better.
            - Disallow this from adding effects with the same name.
            - Check for valid sounds.
        - Also have a seperate "addUniversalEffect" thing too. And make Universal effects a global table.
        - Get a function that adds incompatibilities to effects.

    - Fix all effects that use pw_powers for flashing, replace it with "player.flashing" instead.

    Idea for HUD:
        - Revamp the HUD system by using player.khaoshuditems instead. Then, effects that get removed can stay there for a little bit to do an animation.
            - Would make the instant-use effects show better.
            - Have effect icons drop off when they expire.
                - Or make them transparent and grow in size? I did make this something that can scale after all.
                    - Would need to center it though...

    - Add icon next to the universal effects text, show it actively rolling for effects too, that'd be fun.

]]

            --GT_RACE, GT_BATTLE, GT_SPECIAL, GT_VERSUS, GT_TUTORIAL

rawset(_G, "TailsKK", TailsKK)

freeslot(
"S_COLORRING",
"MT_JIMBO",
"S_CHAOTICPIZZA",
"SPR_CHPI",
"SPR_CHUK", -- don't import this when backporting to SRB2!
"S_CHAOTICUNKNOWN",
"sfx_chslrp",
"sfx_chapis",
"sfx_chapki",
"sfx_boo",
"sfx_slappy",
"sfx_chgc",
"S_CHAOTICXPLOSPIZZA",
"S_CHAOTICPIZZAFACE",
"SPR_SOSS",
"S_SOSS_RUN1",
"S_SOSS_RUN2",
"S_SOSS_RUN3",
"S_SOSS_RUN4",
"S_SOSS_RUN5",
"S_SOSS_RUN6",
--[["SPR_CEIB",
"SPR_CEIC",
"SPR_CEID",
"SPR_CDVD",]]
"SPR_CHPF",
"SPR_TRNG", -- don't import this when backporting to SRB2!
"sfx_chadet",
"sfx_camin",
"sfx_camout",
"sfx_chcake",
"sfx_chrewi",
"sfx_chyeet",
"sfx_chyee2",
"sfx_chlank",
"sfx_chtxed",
"sfx_chtxst",
"sfx_chtxad",
"MT_ICESHRAPNELCHAOTIC", "S_ICESHRAPCH", "S_ICESHRAP2CH", "S_ICESHRAP3CH", "S_ICESHRAP4CH", "SPR_ISHC",
"MT_CHANGESPRITE",
"MT_LAGPLAYER",
"sfx_cinsit", -- insta-item
"sfx_cinsi2",
"sfx_cbees", -- you get the bees
"sfx_cbees2",
"sfx_cposwa", -- position swap
"sfx_cposw2",
"sfx_cssrac", -- supersonic racing
"sfx_cssra2",
"sfx_ckabom", -- kaboom
"sfx_ckabo2",
"sfx_cscram", -- scramble
"sfx_ctrain", -- trap rain
"sfx_ctrai2",
"sfx_cditem", -- double items
"sfx_cdite2",
"sfx_cquadi", -- quadruple items
"sfx_cquad2",
"sfx_cwacky", -- wacky textures
"sfx_cwack2",
--ms sam voices
"sfx_mkabom", -- kaboom
"sfx_mkabo2",
"sfx_mbees", -- you get the bees
"sfx_mbees2",
"sfx_minsit", -- insta-item
"sfx_minsi2",
"sfx_mditem", -- double items
"sfx_mdite2",
"sfx_mquadi", -- quadruple items
"sfx_mquad2",
"sfx_mssrac", -- supersonic racing
"sfx_mssra2",
"sfx_mtrain", -- trap rain
"sfx_mtrai2",
"sfx_mwacky", -- wacky textures
"sfx_mwack2"
)

states[S_CHAOTICPIZZAFACE] = {
    sprite = SPR_CHPF,
    frame = FF_ANIMATE|FF_GLOBALANIM,
    --tics = 4,
    var1 = 15,
    var2 = 2,
    nextstate = S_CHAOTICPIZZAFACE
}

states[S_SOSS_RUN1] = {
    sprite = SPR_SOSS,
    frame = A,
    tics = 3,
    nextstate = S_SOSS_RUN2
}

states[S_SOSS_RUN2] = {
    sprite = SPR_SOSS,
    frame = B,
    tics = 3,
    nextstate = S_SOSS_RUN3
}

states[S_SOSS_RUN3] = {
    sprite = SPR_SOSS,
    frame = C,
    tics = 3,
    nextstate = S_SOSS_RUN4
}

states[S_SOSS_RUN4] = {
    sprite = SPR_SOSS,
    frame = D,
    tics = 3,
    nextstate = S_SOSS_RUN5
}

states[S_SOSS_RUN5] = {
    sprite = SPR_SOSS,
    frame = E,
    tics = 3,
    nextstate = S_SOSS_RUN6
}

states[S_SOSS_RUN6] = {
    sprite = SPR_SOSS,
    frame = F,
    tics = 3,
    nextstate = S_SOSS_RUN1
}

states[S_CHAOTICPIZZA] = {
    sprite = SPR_CHPI,
    tics = -1
}

states[S_CHAOTICUNKNOWN] = {
    sprite = SPR_CHUK,
    tics = -1
}

states[S_CHAOTICXPLOSPIZZA] = {
    sprite = SPR_CHPI,
    frame = B,
    tics = -1
}

states[S_COLORRING] = {
    sprite = SPR_TRNG,
    frame = FF_ANIMATE|FF_GLOBALANIM,
    tics = -1,
    var1 = 23,
    var2 = 1,
    nextstate = S_COLORRING
}

mobjinfo[MT_JIMBO] = {
    doomednum = -1,
    spawnstate = S_CHAOTICPIZZA,
    speed = 36*FRACUNIT,
    height = 128*FRACUNIT,
    radius = 25*FRACUNIT,
    flags = MF_NOGRAVITY|MF_NOCLIP
}

mobjinfo[MT_CHANGESPRITE] = {
    doomednum = -1,
    spawnstate = S_COLORRING,
    radius = 16*FRACUNIT,
    height = 48*FRACUNIT,
    flags = MF_NOGRAVITY|MF_NOCLIP
}

mobjinfo[MT_LAGPLAYER] = {
    doomednum = -1,
    spawnstate = S_COLORRING,
    radius = 16*FRACUNIT,
    height = 48*FRACUNIT,
    flags = MF_NOGRAVITY|MF_NOCLIP
}

sfxinfo[sfx_chapis] = {
    singular = false,
    priority = 64,
    flags = SF_X4AWAYSOUND,
    caption = "The pizza is aggressive!"
}

sfxinfo[sfx_chapki] = {
    singular = false,
    priority = 129,
    caption = "\"Oh shit.\""
}

sfxinfo[sfx_boo] = {
    singular = false,
    priority = 64,
    caption = "BoOoO!"
}

sfxinfo[sfx_slappy] = {
    singular = false,
    priority = 64,
    caption = "Slapped"
}

sfxinfo[sfx_chgc] = {
    singular = false,
    priority = 64,
    caption = "Coiled spring"
}

sfxinfo[sfx_chadet] = {
    singular = false,
    priority = 64,
    caption = "Flare gun"
}

states[S_ICESHRAPCH] = {SPR_ISHC, A, -1, nil, 0, 0, S_NULL}
states[S_ICESHRAP2CH] = {SPR_ISHC, B, -1, nil, 0, 0, S_NULL}
states[S_ICESHRAP3CH] = {SPR_ISHC, C, -1, nil, 0, 0, S_NULL}
states[S_ICESHRAP4CH] = {SPR_ISHC, D, -1, nil, 0, 0, S_NULL}

mobjinfo[MT_ICESHRAPNELCHAOTIC] = {
    doomednum = -1,
    spawnstate = S_ICESHRAPCH,
    height = 5*FRACUNIT,
    radius = 5*FRACUNIT,
    flags = MF_NOCLIPTHING
}

local function DebugPrint(player, text)
    if tonumber(CV_FindVar("tkkDebug").value) then
        print("PLYR: " + player.name + ", TEXT: " + text)
    end
end

local optionstableofdoom = {
{name = "tkkEnabled", values = {0, 1}, typer = "number", localonly = true},
{name = "tkkAmplify", values = {0, 1}, typer = "number", localonly = true},
{name = "tkkUniversalTimer", values = {10, 100}, typer = "number", localonly = true},
{name = "tkkUniversalFxEnabled", values = {0, 1}, typer = "number", localonly = true},
{name = "tkkDebug", values = {0, 1}, typer = "number", localonly = true},
{name = "tkkMemory", values = {0, 14}, typer = "number"},
{name = "tkkRouletteSFX", values = {0, 1}, typer = "number"},
{name = "tkkPrintEffect", values = {0, 1}, typer = "number"},
{name = "tkkUniversalAnnouncer", values = {0, 1}, typer = "number"},
{name = "tkkHUD", values = {0, 1}, typer = "number"},
{name = "tkkHUDTimerBar", values = {0, 1}, typer = "number"},
{name = "tkkHUDPosition", values = {0, 1}, typer = "number"},
{name = "tkkHUDTextBorder", values = {0, 1}, typer = "number"},
{name = "tkkHUDOverride", values = {0, 1}, typer = "number"},
{name = "tkkRainbowTimer", values = {0, 1}, typer = "number"}}

local KhaosEffectsTable = {}
rawset(_G, "KhaosEffectsTable", KhaosEffectsTable)
local KhaosNamesOnlyTable = {}

local ueTimer = 0
local ueTimerBuffer = 0
local ueTimerMax = 69 * TICRATE -- DON'T CHANGE THIS! CHANGE IT IN MAPCHANGE!

local initiateUE = false

local botcount = 0
local playercount = 0
local hasanyonefinished = false

local tkkEnabled = 1
rawset(_G, "tkkEnabled", tkkEnabled)

local function ValidityCheck(player)
    if not player.valid return false end
    if not player.mo return false end
    if player.bot and gametype != GT_RACE return false end -- apparantly bots are supposed to be spectators in non-race modes. they're not. so we have to do this >:(
    if player.spectator return false end
    if not player.khaos return false end
    if not tkkEnabled return false end

    return true
end

local function indexOf(array, value)
    for i, v in ipairs(array) do
        if v == value then
            return i
        end
    end
    return nil
end

local function keyOf(tbl, value)
    for k, v in pairs(tbl) do
        if v == value then
            return k
        end
    end
    return nil
end

local function indexOfName(array, value) --thanks to amperbee for telling me the obvious that i can just modify this function lol
    for i, v in ipairs(array) do
        if v.name == value then
            return i
        end
    end
    return nil
end

local function indexOfName2(array, value)
    for i, v in ipairs(array) do
        if string.lower(v.name) == string.lower(value) then -- makes this case insensitive
            return i
        end
    end
    return nil
end

local function rainbowtext(string, offset) -- if you use this, leave this credit for me: Ibly/EeveeEuphoria
    local indexer = 0
    if offset then
        indexer = offset
    end
    local colortable = {"\x85", "\x87", "\x82", "\x83", "\x8B", "\x84", "\x8C", "\x89", "\x81"} -- length is 9
    local rainbowed = ""

    for c in string:gmatch"." do
        if c != " " then
            indexer = $ + 1
            if indexer > #colortable then
                indexer = 1
            end
            c = colortable[indexer] + $
        end
        rainbowed = $ + c
    end
    return rainbowed
end

local function fullcolors(string, offset) -- if you use this, leave this credit for me: Ibly/EeveeEuphoria
    local indexer = 0
    if offset then
        indexer = offset
    end
    local colortable = {"\x80", "\x81", "\x82", "\x83", "\x84", "\x85", "\x86", "\x87", "\x88", "\x89", "\x8A", "\x8B", "\x8C", "\x8D", "\x8E", "\x8F"}
    local rainbowed = ""

    for c in string:gmatch"." do
        if c != " " then
            indexer = $ + 1
            if indexer > #colortable then
                indexer = 1
            end
            c = colortable[indexer] + $
        end
        rainbowed = $ + c
    end
    return rainbowed
end

local function addHUDText(player, string, override, extend, color)
    if not player.khaosoptions.tkkHUD and not override then return end
    extend = extend or 0 -- can't wait to not remember to fix all my code that doesn't do this
    local tbl = {text = string, trans = 0, timer = 0, expire = ((4 + extend)*TICRATE)- player.khaos.addHUDTextRando, color = color}
    local sendplayer = player

    table.insert(sendplayer.khaostext, tbl)
    sendplayer.khaos.addHUDTextRando = P_RandomRange(5, 10) -- done for text added one after another, to randomize the timer a bit

    DebugPrint(player, player.name + ": " + string)
end

local function SaveSettings(player, silent)
    for key, valuable in pairs(optionstableofdoom) do
        if not valuable.localonly then --TODO: allow admin to save their own local/netvar settings
            local name = "client/tailskhaoskontraption/" .. valuable.name .. ".dat"
            local savefile = io.openlocal(name, "w")
            if savefile != nil then
                local Saver = CV_FindVar(valuable.name).value
                if player and player.khaosoptions then
                    Saver = player.khaosoptions[valuable.name]
                end
                local TheValue = savefile:write(Saver)
            end
        end
    end
    if player and player.khaos and not silent then
        addHUDText(player, "\199" + "Saved settings!", true, 4)
        S_StartSound(player.mo, sfx_addfil, player)
    else
        CONS_Printf(player, rainbowtext("Saved settings!"))
    end
end

local function LoadSettings(player)
    if player and player.khaos then player.khaos.LoadFailed = false end -- reset this at the start
    for key, value in pairs(optionstableofdoom) do
        if not value.localonly then -- TODO: make it so admins can load this, but only once! make a netvar called "AdminLoadedSettings" to prevent other admins auto-loading
            local name = "client/tailskhaoskontraption/" .. value.name .. ".dat"
            local loadedfile = io.openlocal(name, "r")
            if loadedfile != nil then
                local TheValue = loadedfile:read("*all")
                local TheType = "zkhaosDONOTUSEMEPLEASE1 " -- the space is important, don't forget this
                if value.typer == "string" then
                    TheType = "zkhaosDONOTUSEMEPLEASE2 "
                end
                if player then
                    COM_BufInsertText(player or consoleplayer, TheType + value.name + " " + TheValue)
                else --consoleplayer is loading this
                    COM_BufInsertText(consoleplayer, value.name + " " + TheValue)
                end
            end
        end
    end
    if player and player.khaos then player.khaos.OptionsLoaded = true end
end

local function GivePizza(player)
    player.khaos.PizzaRemoval = nil
    local thepizzais = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.ceilingz-(6*FRACUNIT), MT_JIMBO)
    thepizzais.target = player.mo

    local size
    local choosesize = P_RandomRange(1, 4)

    if tonumber(CV_FindVar("tkkAmplify").value) then
        choosesize = P_RandomRange(2, 5)
    end

    if choosesize == 1 then
        size = "small"
    elseif choosesize == 2 then
        size = "medium"
    elseif choosesize == 3 then
        if P_RandomChance(FRACUNIT/2) then
            size = "large"
        else
            if P_RandomChance(FRACUNIT/2) then
                size = "medium"
            else
                size = "small"
            end
        end
    elseif choosesize == 4 then
        if P_RandomChance(FRACUNIT/99) then -- extrodionarly rare chance!
            size = "extra large"
        else
            if P_RandomChance(FRACUNIT/2 + FRACUNIT/3) then
                size = "medium"
            else
                if P_RandomChance(FRACUNIT/2) then
                    size = "small"
                else
                    size = "large"
                end
            end
        end
    elseif choosesize == 5 then -- only happens in bad mode
        size = "extra large"
    end

    if not size then -- failsafe, just for in case of some really weird situation occuring
        size = "small"
    end

    if size == "large" or size == "medium" or size == "small" or size == "personal" or size == "xl" or size == "extra large"  or size == "extralarge" then -- REMOVE THIS LATER
        thepizzais.sizeoption = size
    end

    local toppings = "pepperoni"

    if P_RandomChance(FRACUNIT/4) then
        thepizzais.state = S_CHAOTICXPLOSPIZZA
        toppings = "deton"
    elseif P_RandomChance(FRACUNIT/6) then
        thepizzais.state = S_CHAOTICPIZZAFACE
        toppings = "pizza face"
    end

    if not player.khaos.PizzaGivenAlready then
        local StringMan = rainbowtext(player.name) .. "\x80 has ordered a " .. size .. " sized pizza, with " .. toppings .. " toppings to themself."
        print(StringMan)
        if netgame then chatprint(StringMan, true) end
    end
    player.khaos.PizzaSpawned = true
end

TailsKK.addHUDText = addHUDText

local function addEffect(tbl)
    -- basic sanity checks
    if not tbl.name then
        assert(nil, "ERROR: Invalid or no name given to effect!")
    end
    if tbl.chance == nil then
        assert(nil, "ERROR: Invalid or no 'chance' value set!")
    end
    if tbl.duration == nil or type(tbl.duration) != "number" then
        assert(nil, "ERROR: Invalid or no 'duration' value set!")
    end
    -- do NOT error out if no icon/sprite is there, that's something i use and is accounted for
    for key, value in pairs(KhaosEffectsTable) do
        if tbl.name == value.name then
            assert(nil, "ERROR: Effect name is already taken by something else!")
        end
    end
    table.insert(KhaosEffectsTable, tbl)
    table.insert(KhaosNamesOnlyTable, tbl.name)
end

TailsKK.addEffect = addEffect

local function GlobalNonConflict(effectid) -- this is all the stuff that isn't player specific. used mainly for "you get the bees"
    local effecter = KhaosEffectsTable[effectid]

    if effecter.dontrollme then
        --DebugPrint(player, "don't roll this!")
        return false
    end

    if effecter.nobattle and gametype == GT_BATTLE then
        --DebugPrint(player, "we're in battle mode, skip")
        return false
    end

    if effecter.battleonly and gametype != GT_BATTLE then
        --DebugPrint(player, "this isn't battle mode!")
        return false
    end

    if effecter.amplifyonly and not tonumber(CV_FindVar("tkkAmplify").value) then
        --DebugPrint(player, "amplify mode on, not rolling")
        return false
    end

    return true
end

local function CheckNonConflict(player, effectid, ignoreotherincompats)
    if not ignoreotherincompats then
        ignoreotherincompats = 0
    end
    local effecter = KhaosEffectsTable[effectid]
    -- check if effect exists first
    DebugPrint(player, "checking nonconflict: " + effecter.name)

    for key, value in pairs(player.khaoseffects) do
        if value.effect == effectid then
            DebugPrint(player, "effect is already applied to player, skip")
            return false
        end
        if KhaosEffectsTable[value.effect].incompatible and ignoreotherincompats <= 1 then -- check pre-existing effects on the player, to see if they're incompatible
            local incompatibleTable = KhaosEffectsTable[value.effect].incompatible
            for key2, value2 in pairs(incompatibleTable) do
                --print(value2)
                if value2 == effecter.name then
                    DebugPrint(player, "incompatible effect found")
                    return false
                end
            end
        end
        if effecter.incompatible and ignoreotherincompats <= 1 then -- now, do the inverse; check this effect's incompatibilities, and see if they exist in the player
            for key2, value2 in pairs(effecter.incompatible) do
                if value2 == KhaosEffectsTable[value.effect].name then
                    DebugPrint(player, "incompatible effect found second-way around")
                    return false
                end
            end
        end
    end


    if ignoreotherincompats <= 2 then
        if not GlobalNonConflict(effectid) then
            --DebugPrint(player, "effect doesn't pass globalnonconflict")
            return false
        end

        if effecter.nobot and player.bot then
            DebugPrint(player, "player is a bot, ergo invalid")
            return false
        end

        if effecter.fxrequired and #player.khaoseffects < effecter.fxrequired then
            DebugPrint(player, "not enough effects. need: " .. effecter.fxrequired)
            return false
        end
    end


    if not ignoreotherincompats then -- put misc. incompatibilities here
        if effecter.requirerings and player.rings <= 0 then
            DebugPrint(player, "player doesn't have rings!")
            return false
        end
        if effecter.grounded and not P_IsObjectOnGround(player.mo) then
            DebugPrint(player, "player isn't on the ground!")
            return false
        end
        if player.khaosoptions.tkkMemory > 0 then
            for key, value in pairs(player.khaosmemory) do
                if value == effectid then -- recently rolled, don't apply this again for a little bit
                    DebugPrint(player, "found in memory: " .. value)
                    return false
                end
            end
        end
    end


    -- all else checks out, let's go
    return true
end

TailsKK.GlobalNonConflict = GlobalNonConflict
TailsKK.CheckNonConflict = CheckNonConflict

local function ApplyEffect(player, effect, extravalues)
    local dex = tonumber(effect) or indexOfName(KhaosEffectsTable, effect) -- dex 2: enter the decko. no but, get the index so we can point to the right table.
    if dex == nil then
        assert(nil, "ERROR: Effect not found!")
    end
    local effecter = KhaosEffectsTable[dex]
    if player.khaosoptions.tkkHUD or effecter.forcestart then
        if effecter.startsfx then
            if effecter.localsfx then
                S_StartSound(player.mo, effecter.startsfx, player)
            else
                S_StartSound(player.mo, effecter.startsfx)
            end
        end
    end

    local funnyduration = 0

    if effecter.duration > 0 and effecter.range then
        local mintime = max(effecter.duration - (effecter.range/3), effecter.duration/2 + 1) -- done to prevent effect from going under half it's time
        local maxtime = effecter.duration + (effecter.range + 2)


        funnyduration = P_RandomRange(mintime, maxtime)

        if tonumber(CV_FindVar("tkkAmplify").value) and effecter.addition then -- just for a lil more spice on top of the extended timers
            funnyduration = $ + effecter.addition
        end
    else
        funnyduration = effecter.duration
    end

    DebugPrint(player, effect + ": " + dex)

    local snable = {timer = 0, effect = dex, duration = funnyduration, icon = effecter.sprite, noblink = effecter.noblink, ymax = 175, notimer = effecter.notimer} --hide = effecter.hide
    local HUDPosition = player.khaosoptions.tkkHUDPosition
    if extravalues then
        for key, value in pairs(extravalues) do
            snable[key] = value
        end
    end

    if (consoleplayer and consoleplayer.spectator) or replayplayback then -- done so replays and spectators get their own values set; this shouldn't cause desyncs i hope.
        HUDPosition = tonumber(CV_FindVar("tkkHUDPosition").value)
    end

    if effecter.name == "Roulette" then
        snable.ytime = 215

        if HUDPosition then
            snable.ytime = -30
        end
    else
        snable.ytime = 175
        local memsetting = player.khaosoptions.tkkMemory
        if memsetting > 0 then
            table.insert(player.khaosmemory, dex)
            if #player.khaosmemory > memsetting
                table.remove(player.khaosmemory, 1)
            end
        end
        if HUDPosition then
            snable.ytime = 8
        end
    end

    if HUDPosition then
        snable.ymax = 8
    end

    table.insert(player.khaoseffects, snable)

    if not effecter.nohudtext then
        local prefix = effecter.hudtextprefix or ""
        local color = SKINCOLOR_GREY
        if effecter.effect == "good" then
            color = SKINCOLOR_GREEN
        elseif effecter.effect == "bad" then
            color = SKINCOLOR_RED
        end
        addHUDText(player, prefix + effecter.name, nil, nil, color)
        if player.khaosoptions.tkkHUD and player.khaosoptions.tkkPrintEffect then
            CONS_Printf(player, "*\x83 Applied\x80: " .. effecter.name)
        end
    end
    --play sound if it exists
end

TailsKK.ApplyEffect = ApplyEffect

local TextBoxTable = { -- there's one more text box stapled to the very end of this lua script, just to count all the current effects lol
{{"Finally caught a",
"Simpleflips stream. He",
"spent 2 hours bouncing",
"on the floor as a"},
{"tree, then he fell",
"asleep live on stream.",
"Great entertainer he is.", ""}},
{{"The path is narrow here.",
"Easy does it! No one is",
"allowed on the top of the",
"mountain!"},
{"And if you know what's",
"good for you, you won't",
"wake anyone who's",
"sleeping!"},
{"Move slowly,",
"tread lightly.","",""}},
{{rainbowtext("it's look who it is"),"","",""}},
{{"You just lost The Game.","","","hah"}},
{{"<<" + "\x87" + "DRRR-CR4CK (LEGIT).exe" + "\x80" + ">>",
"The application isn't respond-",
"ing. The program may respond",
"again if you wait."},
{"Do you want to end",
"this process?",
"              [End] [Cancel]", ""}},
{{"welcom 2 my EPIC",
"minecraf base. DO NOT",
"TAKE MY DIAMONDS. THAT",
"MEANS U, JARED!!!!1!!"}},
{{"I had to change the",
"neon sign outside my",
"house from saying",
"..."},
{"\"I've always",
"had radishes\", to",
"\"I've never had",
"radishes\"."}},
{{"Busted! Y'all ready?",
"\"Rap Rat\" is the name,",
"The Video Boab Oyedivuth",
"The Video Boab Oyedivuth"},
{"The Video Boab Oyedivuth",
"The Video Boab Oyedivuth",
rainbowtext("The Video Boab Oyedivuth"), -- just to be silly
"The Video Boab Oyedivuth"},
{"The Video Boab Oyedivuth",
"The Video Boab Oyedivuth",
"The Video Boab Oyedivuth",
"The Video Boab Oyedivuth"}},
{{"Did you know? You can",
"use \x87\"tkkWhatIs\"\x80 in the",
"console to find out more",
"about certain effects!"}}
}

TailsKK.TextBoxTable = TextBoxTable -- this can make it be modified by mods. that's honestly funny tbh. just don't replace them please that'd be rude :(

  addEffect{name = "i taketh", chance = FRACUNIT/18, duration = 0, sprite = "KH_TRASH", effect = "bad", startsfx = sfx_shldls, forcestart = true,
description = "This makes you drop your items, then takes the following: Your drift charge, invincibility and i-frames, 3 rings, and your ring boost.",
func = function(player, selfid, value)
    --P_RemoveShield(player)
    --P_RestoreMusic(player)
    K_DropItems(player)
    player.driftcharge = 0
    player.invincibilitytimer = 0
    player.flashing = 0
    player.ringboost = 0
    P_GivePlayerRings(player, -3)
    value.fxdone = true
end}

  addEffect{name = "Bee Storage", chance = 1/FRACUNIT, duration = 0, effect = "bees", dontrollme = true, nobees = true, nohudtext = true, dontcountme = true, notimer = true,
description = "When \"You Get The Bees\" wants to apply an effect, but you have some incompatible effect applied right now, it will be stored in this until it can be given to you.",
func = function(player, selfid, value)
    if value.timer > TICRATE and (leveltime % 10) == 0 then
        if CheckNonConflict(player, value.storeeffect, 1) then
            value.fxdone = true
        end
    end
end,
endfunc = function(player, selfid, value)
    ApplyEffect(player, KhaosEffectsTable[value.storeeffect].name)
end}

  addEffect{name = "Rewind", chance = FRACUNIT/30, duration = 0, effect = "bad", sprite = "KH_REWIND", nocart = true, nonights = true, startsfx = sfx_chrewi, forcestart = true,
description = "Every 3 seconds a new position is recorded down, and when you get rewind, it will send you back here!",
func = function(player, selfid, value)
    P_SetOrigin(player.mo, player.khaos.RewindX, player.khaos.RewindY, player.khaos.RewindZ)
    if not tonumber(CV_FindVar("tkkAmplify").value) then
        player.mo.angle = player.khaos.RewindAngle
    end
    value.fxdone = true
end}

  addEffect{name = "I WAS FROZEN TODAY!", chance = FRACUNIT/26, duration = 3, range = 1, sprite = "KH_ICE", addition = 1, nospawn = true, effect = "bad", nocart = true, nonights = true,
startsfx = sfx_s3k80, endsfx = sfx_shattr, forcestart = true, forceend = true,
incompatible = {"Change Color", "Cement Tires", "Change Sprite", "Black Hole", "Laggy Model", "Hey! Listen!"},
description = "Your controls are frozen! Shake wildly to speed up the timer!",
func = function(player, selfid, value)
    if not value.started then
        player.khaos.FrozenNow = true
        player.khaos.FrozenWait = 3
        value.FrozenPrevColor = player.mo.color
        value.started = true
    end

    player.mo.colorized = true
    player.mo.color = SKINCOLOR_JAWZ
    player.skincolor = player.mo.color
    if not player.khaos.FrozenState then
        player.khaos.FrozenState = player.mo.state
        player.khaos.FrozenFrame = player.mo.frame
        if player.followmobj then
            player.khaos.FollowFrozenState = player.followmobj.state
            player.khaos.FollowFrozenFrame = player.followmobj.frame
        end
    end

    if player.bot and P_RandomChance(FRACUNIT/10) then
        player.khaos.FrozenShake = true
    end

    if player.khaos.FrozenShake and player.khaos.FrozenWait == 0 then
        S_StartSound(player.mo, sfx_iceb)
        local z = (player.mo.z + player.mo.height) + 6*player.mo.scale
        if (player.mo.eflags & MFE_VERTICALFLIP) then
            z = (player.mo.z - player.mo.height) - 6*player.mo.scale
        end
        local piecespawn = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
        piecespawn.number = P_RandomRange(1, 4)
        piecespawn.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
        value.timer = $ + P_RandomRange(3, 6)
        player.khaos.FrozenWait = 4
    end

    if player.khaos.FrozenWait > 0 then
        player.khaos.FrozenWait = $ - 1
        player.mo.spritexoffset = 0
        player.mo.spriteyoffset = 0
    end

    if player.khaos.FrozenWait == 0 then
        player.khaos.FrozenShake = false
    end
end,
endfunc = function(player, selfid, value)
    player.mo.color = value.FrozenPrevColor
    player.skincolor = player.mo.color
    player.mo.colorized = false
    player.khaos.FrozenNow = false
    player.khaos.FrozenShake = false
    player.khaos.FrozenState = nil
    player.khaos.FollowFrozenState = nil
    player.khaos.FrozenFrame = nil
    player.khaos.FollowFrozenFrame = nil
    player.mo.spritexoffset = 0
    player.mo.spriteyoffset = 0

    local z = (player.mo.z + player.mo.height) + 6*player.mo.scale
    if (player.mo.eflags & MFE_VERTICALFLIP) then
        z = (player.mo.z - player.mo.height) - 6*player.mo.scale
    end

    -- stolen from ice springs, forgive me for this sloppy code, i refuse to fix it just yet
    local piece1 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece2 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece3 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece4 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece5 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece6 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece7 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    local piece8 = P_SpawnMobj(player.mo.x, player.mo.y, z, MT_ICESHRAPNELCHAOTIC)
    piece1.number = 1
    piece2.number = 2
    piece3.number = 3
    piece4.number = 4
    piece1.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece2.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece3.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece4.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))

    piece5.number = 1
    piece6.number = 2
    piece7.number = 3
    piece8.number = 4
    piece5.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece6.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece7.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
    piece8.angle = player.mo.angle + (ANG1 * (P_RandomRange(-360, 360)))
end
}

  addEffect{name = "Giant", chance = FRACUNIT/10, duration = 7, sprite = "KH_GIANT", range = 3, effect = "neutral", restartrespawn = true,
startsfx = sfx_mario3, endsfx = sfx_kc59, forcestart = true, forceend = true,
incompatible = {"Tiny", "HE"},
description = "This makes you giant! This isn't the same thing as the \"Grow\" item, as it won't let you bypass tripwires instantly.",
func = function(player, selfid, value)
    if not value.started then
        value.setscale = (mapobjectscale*3)
        player.mo.destscale = value.setscale
        if value.growshrinktimer == nil then value.growshrinktimer = 0 end
        value.started = true
    end
    if player.growshrinktimer < 0 or player.growshrinktimer > 0 then
        value.growshrinktimer = $ + player.growshrinktimer
        player.growshrinktimer = 0
        player.mo.destscale = value.setscale
    end
end,
endfunc = function(player, selfid, value)
    if value.growshrinktimer < 0 or value.growshrinktimer > 0 then
        player.growshrinktimer = value.growshrinktimer
        if value.growshrinktimer < 0
            player.mo.destscale = FixedMul(mapobjectscale, (FRACUNIT/2))
        else
            player.mo.destscale = FixedMul(mapobjectscale, (2*FRACUNIT))
        end
    else
        player.mo.destscale = mapobjectscale
    end
end}

  addEffect{name = "Tiny", chance = FRACUNIT/13, duration = 6, sprite = "KH_TINY", range = 2, addition = 2, effect = "bad", restartrespawn = true,
startsfx = sfx_mario8, endsfx = sfx_kc5a, forcestart = true, forceend = true,
incompatible = {"Giant"},
description = "This makes you very small! This isn't the same thing as the \"Shrink\" item.",
func = function(player, selfid, value)
    if not value.started then
        value.setscale = (mapobjectscale/4) + (mapobjectscale/8)
        if tonumber(CV_FindVar("tkkAmplify").value) then
            value.destscale = (mapobjectscale/3)
        end
        player.mo.destscale = value.setscale
        if value.growshrinktimer == nil then value.growshrinktimer = 0 end
        value.started = true
    end

    if player.growshrinktimer < 0 or player.growshrinktimer > 0 then
        value.growshrinktimer = $ + player.growshrinktimer
        player.growshrinktimer = 0
        player.mo.destscale = value.setscale
    end
end,

endfunc = function(player, selfid, value)
    if value.growshrinktimer < 0 or value.growshrinktimer > 0 then
        player.growshrinktimer = value.growshrinktimer
        if value.growshrinktimer < 0
            player.mo.destscale = FixedMul(mapobjectscale, (FRACUNIT/2))
        else
            player.mo.destscale = FixedMul(mapobjectscale, (2*FRACUNIT))
        end
    else
        player.mo.destscale = mapobjectscale
    end
end}

  addEffect{name = "Gravity Coil", chance = FRACUNIT/16, duration = 15, range = 4, sprite = "KH_GRAVITYCOIL", addition = 3, nonights = true, effect = "neutral", nocart = true,
startsfx = sfx_chgc, endsfx = sfx_kc65, localsfx = true,
incomaptible = {"Super Jump", "Bouncy Floors", "Cement Tires"},
description = "This makes your falls descend a whole lot slower.",
func = function(player, selfid, value)
    if not P_IsObjectOnGround(player.mo) then
        if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
            if player.mo.momz > 0 then
                player.mo.momz = $ - $ / 25
            elseif player.mo.momz < (9*FRACUNIT * FRACUNIT) then
                player.mo.momz = $ + $ / 2
            end
        else
            if player.mo.momz < 0 then
                player.mo.momz = $ - $ / 25
            elseif player.mo.momz < (9*FRACUNIT * FRACUNIT) then
                player.mo.momz = $ + $ / 2
            end
        end
    end
end}

addEffect{name = "Drifting", chance = FRACUNIT/23, duration = 10, range = 3, sprite = "KH_DRIFTINGLEFT", addition = 1, effect = "bad", nocart = true, nonights = true, nohudtext = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible = {"No Camera Turning", "Invert Controls"},
description = "Simulates Joy-Con(tm) Drift! You will be constantly veering either to the left or right.",
func = function(player, selfid, value)
    --player.cmd.turning -- ranges from -800 to 800, positive is left

    if not value.started then
        value.started = true
        value.adjustvalue = 450
        if P_RandomChance(FRACUNIT/2) then
            value.icon = "KH_DRIFTINGRIGHT"
            value.adjustvalue = -450
            addHUDText(player, "Drifting Right")
        else
            addHUDText(player, "Drifting Left")
        end
    end

    player.khaos.BorkedSteering = value.adjustvalue
end,

endfunc=function(player, selfid, value)
    player.khaos.BorkedSteering = nil
end}

addEffect{name = "Earthquake", chance = FRACUNIT/16, duration = 10, range = 8, effect = "bad", sprite = "KH_EARTHQUAKE", nobot = true, hudtextprefix = "\202",
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
description = "Causes your screen to shake violently! If you're near anyone else, their screen will also be shaking!",
func = function(player, selfid, value)
    if (leveltime % 10 == 0) then
        if tonumber(CV_FindVar("tkkAmplify").value) then
            P_StartQuake(13, 25*FRACUNIT, 45*FRACUNIT, player.mo)
        else
            P_StartQuake(9, 15*FRACUNIT, 30*FRACUNIT, player.mo)
        end
    end
end
}

addEffect{name = "Nuke", chance = FRACUNIT/40, duration = 0, sprite = "KH_NUKE", nonights = true, effect = "good", startsfx = sfx_gshbe, --sfx_gshdd. sfx_gshcd, sfx_gshc5
description = "Sets off a bunch of bombs right around your player, damaging everyone nearby! You'll dodge the hit... unless you're very unlucky.",
func = function(player, selfid, value)
    if not P_RandomChance(FRACUNIT/90) -- >:3c
        player.khaos.DodgeHit = true -- jank ass solution to give the player invincibility frames
    end

    local JankSplosion = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SSMINE)
    JankSplosion.scale = mapobjectscale * 5
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    local JankSplosion = P_SpawnMobj(player.mo.x+50*FRACUNIT, player.mo.y, player.mo.z, MT_SSMINE)
    JankSplosion.scale = mapobjectscale * 3
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    local JankSplosion = P_SpawnMobj(player.mo.x, player.mo.y+50*FRACUNIT, player.mo.z, MT_SSMINE)
    JankSplosion.scale = mapobjectscale * 3
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    local JankSplosion = P_SpawnMobj(player.mo.x-50*FRACUNIT, player.mo.y, player.mo.z, MT_SSMINE)
    JankSplosion.scale = mapobjectscale * 3
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    local JankSplosion = P_SpawnMobj(player.mo.x, player.mo.y-50*FRACUNIT, player.mo.z, MT_SSMINE)
    JankSplosion.scale = mapobjectscale * 3
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    -- this cause a shit ton of lag. i am not fixing this.
    player.khaos.DodgeHit = false
    value.fxdone = true
end}


  addEffect{name = "Reversed!", chance = FRACUNIT/33, duration = 0, effect = "bad", sprite = "KH_REVERSED", amplifyonly = true, startsfx = sfx_s3kaa,
description = "Amplify Mode exclusive effect, this instantly turns you around 180 degrees!",
func = function(player, selfid, value)
    player.mo.angle = player.mo.angle + ANGLE_180
    if tonumber(CV_FindVar("tkkAmplify").value) then
        player.mo.momx = -player.mo.momx
        player.mo.momy = -player.mo.momy
    end
    value.fxdone = true
end}

  addEffect{name = "the pizza is aggressive", chance = FRACUNIT/37, duration = 10, range = 15, sprite = "KH_PIZZA", addition = 3, effect = "bad",
description = "\x83\"Bond with me, Jimmy.\"\x80 You order a pizza, but it's aggressive! This will chase you until it hits you, or the timer runs out.",
startsfx = sfx_chapis, endsfx = sfx_kc65, forcestart = true,
func = function(player, selfid, value)
    if not player.khaos.PizzaSpawned and not player.respawn.state then
        GivePizza(player)
        player.khaos.PizzaGivenAlready = true
    end
    if player.khaos.PizzaHitTarget then
        if player.khaos.PizzaHitTarget then
            addHUDText(player, "Delivery complete, enjoy your pizza!", true)
            value.timer = 69*TICRATE -- nice
        end
    end

    if player.respawn.state then
        player.khaos.PizzaSpawned = nil
    end
end,
endfunc = function(player, selfid, value)
    player.khaos.PizzaSpawned = false
    player.khaos.PizzaRemoval = true
    player.khaos.PizzaHitTarget = false
    player.khaos.PizzaGivenAlready = false
end}

  addEffect{name = "Insta-Boost", chance = FRACUNIT/17, duration = 0, sprite = "KH_WIND", effect = "neutral",
description = "\x83\"You got boost power!\"\x80 This instantly applies a sneaker boost to the player.",
func = function(player, selfid, value)
    player.ringboost = $ + 600
    if P_IsObjectOnGround(player.mo) then
        K_DoSneaker(player, 0)
    else
        K_DoSneaker(player, 2)
    end
    value.fxdone = true
end}

addEffect{name = "No Turning", chance = FRACUNIT/38, effect = "bad", duration = 2, sprite = "KH_NOTURNING", addition = 1,
description = "Disables your turning! Lasts only 2 seconds. Or 3 in Amplify Mode!",
startsfx = sfx_s3kb2, endsfx = sfx_kc65, localsfx = true,
incompatible = {"Drifting", "Busted Controller"},
func = function(player, selfid, value)
    if not value.started then
        value.pangle = player.mo.angle
        value.started = true
    end

    player.mo.angle = value.pangle
end}

  addEffect{name = "Hop!", chance = FRACUNIT/10, duration = 0, sprite = "KH_PLACEHOLDER", startsfx = sfx_sprong, effect = "neutral", forcestart = true,
description = "Springs you upward with great velocity!",
func = function(player, selfid, value)
    player.mo.momz = 15*FRACUNIT
    value.fxdone = true
end}

  addEffect{name = "Laggy Model", chance = FRACUNIT/31, duration = 12, range = 5, sprite = "KH_PLACEHOLDER", effect = "bad", --freezeremove = true,
startsfx = sfx_kc65, endsfx = sfx_kc65, forcestart = true, forceend = true,
incompatible = {"I WAS FROZEN TODAY!", "Invisible", "Change Sprite"},
description = "Causes your player's sprite/model to lag behind.",
func = function(player, selfid, value)
    if not value.started then
        value.thej = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_LAGPLAYER)
        value.thej.gayer = player
        player.khaos.InvisibleNow = true
        player.khaos.InvisibleBegone = false
        value.started = true
    end

    if (leveltime % (TICRATE/6) == 0) then
        P_RemoveMobj(value.thej)
        value.started = false
    end

    if value.thej and value.thej.valid then
        if (player.mo.renderflags & RF_DONTDRAW) then -- used to get invincibility frames to render
            value.thej.Blinker = true
        else
            value.thej.Blinker = false
        end
    end



end,
endfunc = function(player, selfid, value)
    if value.thej and value.thej.valid then
        P_RemoveMobj(value.thej)
    end
    player.khaos.InvisibleNow = false
    player.khaos.InvisibleBegone = true

    local dust = P_SpawnMobj(player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.z, MT_DUST)
    dust.scale = FRACUNIT*2
    dust.state = S_XPLD1
end}

  addEffect{name = "Change Sprite", chance = FRACUNIT/10, duration = 18, range = 15, sprite = "KH_CHSPRITE", effect = "neutral",
startsfx = sfx_kc65, endsfx = sfx_kc65, forcestart = true, forceend = true,
incompatible = {"I WAS FROZEN TODAY!", "Invisible", "Laggy Model"},
description = "Changes your player's sprite/model to be completely different!",
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        player.khaos.ChangeSpriteNow = true
        player.khaos.InvisibleNow = true

        local funnystates = {S_PFLW, S_GLDR, S_KART_TIRE2, S_KART_LEFTOVER, S_KART_LEFTOVER_NOTIRES, S_CHAOTICUNKNOWN, S_YELLOWSPRING1, S_YHORIZ1, S_BUSH, S_SOSS_RUN1, S_GFZTREE, S_GARGOYLE, S_COLORRING, S_CHAOTICPIZZA}
        local SPRITE = funnystates[P_RandomRange(1, #funnystates)]
        -- S_SSHELL_RUN1, doesn't work :(

        local dust = P_SpawnMobj(player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)),
        player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.z, MT_DUST)
        dust.scale = FRACUNIT*2
        dust.state = S_XPLD1

        player.khaos.ChangeSpriteMOBJ = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_CHANGESPRITE)
        player.khaos.ChangeSpriteMOBJ.gayer = player
        player.khaos.ChangeSpriteMOBJ.state = SPRITE
        player.khaos.ChangeSpriteMOBJ.flags = $ & ~MF_ENEMY
        player.khaos.ChangeSpriteMOBJ.flags = $ & ~MF_NOTHINK
        player.khaos.ChangeSpriteMOBJ.summonedasstate = SPRITE
    end

    if player.khaos.ChangeSpriteMOBJ and player.khaos.ChangeSpriteMOBJ.valid then
        if (player.mo.renderflags & RF_DONTDRAW) then -- used to get invincibility frames to render
            player.khaos.ChangeSpriteMOBJ.Blinker = true
        else
            player.khaos.ChangeSpriteMOBJ.Blinker = false
        end
    end
end,
endfunc = function(player, selfid, value)
    player.khaos.ChangeSpriteNow = false
    if player.khaos.ChangeSpriteMOBJ and player.khaos.ChangeSpriteMOBJ.valid then
        player.khaos.ChangeSpriteMOBJ.despawn = true
        player.khaos.ChangeSpriteMOBJ = nil
    end
    player.khaos.InvisibleNow = false
    player.khaos.InvisibleBegone = true

    local dust = P_SpawnMobj(player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.z, MT_DUST)
    dust.scale = FRACUNIT*2
    dust.state = S_XPLD1
end}

  addEffect{name = "Hey! Listen!", chance = FRACUNIT/34, duration = 15, sprite = "KH_PLACEHOLDER", effect = "bad", nobees = true, nobot = true, immune2remove = true, notimer = true,
startsfx = sfx_chtxst, endsfx = sfx_chtxed, forcestart = true, forceend = true,
incompatible = {"Hop!", "Fling Player", "Rewind", "Bouncy Floors", "Insta-Boost", "Windy Day", "Quicksand!", "I WAS FROZEN TODAY!"},
description = "Pops up an annoying text box. Let go of accelerate and press it again to get through the text!",
func = function(player, selfid, value)
    if not value.started then
        player.khaos.TextBoxStation = P_RandomRange(1, #TextBoxTable)
        player.khaos.TextBoxPage = 1 --#TextBoxTable[TextBoxStation]
        player.khaos.TextBoxFader = 8
        player.khaos.TextBoxAdvancePage = 30
        player.khaos.FadeTextBoxIn = 1
        player.khaos.prevmomx = player.mo.momx
        player.khaos.prevmomy = player.mo.momy
        player.khaos.prevmomz = player.mo.momz
        player.khaos.keepangle = player.mo.angle
        value.started = true
    end

    if player.khaos.TextBoxFlipPage then
        player.khaos.TextBoxFlipPage = false
        if player.khaos.TextBoxPage + 1 > #TextBoxTable[player.khaos.TextBoxStation] then
            player.khaos.FadeTextBoxOut = 1
            value.timer = (value.duration * TICRATE) - (3*TICRATE)
        else
            player.khaos.TextBoxPage = $ + 1
        end
    end

    player.mo.angle = player.khaos.keepangle
    if not player.respawn.state then
        player.mo.momx = 0
        player.mo.momy = 0
        player.mo.momz = 0
    end
    player.spinouttype = KSPIN_IFRAMES
    player.flashing = 2

    if player.khaos.FadeTextBoxIn then
        player.khaos.FadeTextBoxIn = $ + 1
        if ((player.khaos.FadeTextBoxIn-2*TICRATE)*2) % 2 == 0 then
            player.khaos.TextBoxFader = $ - 1
        end
        if player.khaos.TextBoxFader == 0 then
            player.khaos.FadeTextBoxIn = 0
        end
    end

    if not player.khaos.FadeTextBoxOut and value.timer == (value.duration * TICRATE) - (1*TICRATE) then -- fade out text box near timer end, to make it look smoother
        player.khaos.FadeTextBoxOut = 1
    end

    if player.khaos.FadeTextBoxOut then
        player.khaos.FadeTextBoxOut = $ + 1
        if ((player.khaos.FadeTextBoxOut-2*TICRATE)*2) % 2 == 0 then
            player.khaos.TextBoxFader = $ + 1
        end
        if player.khaos.TextBoxFader > 9 then
            player.khaos.TextBoxStation = nil
            player.khaos.FadeTextBoxOut = 0
            player.khaos.TextBoxFader = 0
            value.fxdone = true
        end
    end

    if player.khaos.TextBoxAdvancePage > 0 then
        player.khaos.TextBoxAdvancePage = $ - 1
    end

    if (player.cmd.buttons & BT_ACCELERATE)
        if player.khaos.TextBoxStation and not player.khaos.HoldAccelerate and not player.khaos.TextBoxAdvancePage then
            player.khaos.TextBoxAdvancePage = 20
            player.khaos.TextBoxFlipPage = true
            if player.khaos.TextBoxPage + 1 <= #TextBoxTable[player.khaos.TextBoxStation] then
                S_StartSound(player.mo, sfx_chtxad, player)
            end
        end
        player.khaos.HoldAccelerate = true
    else
        player.khaos.HoldAccelerate = false
    end

end,
endfunc = function(player, selfid, value)
    player.mo.momx = player.khaos.prevmomx
    player.mo.momy = player.khaos.prevmomy
    player.mo.momz = player.khaos.prevmomz

    player.khaos.TextBoxStation = nil
    player.khaos.FadeTextBoxOut = 0
    player.khaos.TextBoxFader = 0
end}

  addEffect{name = "Quicksand!", chance = FRACUNIT/50, duration = 2, sprite = "KH_PLACEHOLDER", effect = "bad", nobees = true, grounded = true,
startsfx = sfx_chslrp, forcestart = true,
incompatible = {"Bouncy Floors", "Windy Day", "Insta-boost", "Hey! Listen!"},
description = "You got slurped by the ground! You respawn after this effect goes away.",
func = function(player, selfid, value)
    if not value.started then
        value.offsetter = 0
        value.adder = FRACUNIT*2
        player.spinouttype = KSPIN_WIPEOUT
        player.spinouttimer = value.duration*TICRATE
        player.mo.state = S_KART_SPINOUT
        value.started = true
    end

    value.offsetter = $ - value.adder
    value.adder = $ + (FRACUNIT/10)

    player.mo.momx = 0
    player.mo.momy = 0
    player.mo.momz = 0

    -- player.mo.angleroll = $ + ANG1
    player.mo.spriteyoffset = value.offsetter
    player.mo.spritexoffset = 1
end,
endfunc = function(player, selfid, value)
    player.mo.spritexoffset = 0
    player.mo.spriteyoffset = 0
    P_DamageMobj(player.mo, nil, nil, 1, DMG_DEATHPIT)
end}

  addEffect{name = "HE", chance = FRACUNIT/39, duration = 16, range = 6, sprite = "KH_HE", addition = 3, effect = "neutral", nonights = true, nocart = true, -- our lord and savior, Lanky "Christ" Kong
startsfx = sfx_chlank, endsfx = sfx_kc65, forcestart = true,
incompatible = {"Pancake", "Giant", "Black Hole", "Cement Tires"},
description = "You have no style, you have no grace, t-t-t-this player has unusual speed properties!",
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        value.GOALY = FRACUNIT*4 - FRACUNIT/4
        value.GOALX = FRACUNIT/3 + FRACUNIT/4
        value.Defaultkartspeed = player.kartspeed
        value.Defaultkartweight = player.kartweight
        if tonumber(CV_FindVar("tkkAmplify").value) then
            value.GOALY = FRACUNIT*4 - FRACUNIT/6
            value.GOALX = FRACUNIT/2 + FRACUNIT/4
        end
        player.khaos.RestoreSpriteXScaleUp = nil
        player.khaos.RestoreSpriteYScaleUp = nil
        player.khaos.RestoreSpriteXScaleDown = nil
        player.khaos.RestoreSpriteYScaleDown = nil
    end

    if player.mo.spritexscale != value.GOALX then
        if player.mo.spritexscale < value.GOALX then
            player.mo.spritexscale = $ + FRACUNIT/2
        elseif player.mo.spritexscale > value.GOALX then
            player.mo.spritexscale = value.GOALX
        end
    end
    if player.mo.spriteyscale != value.GOALY then
        if player.mo.spriteyscale < value.GOALY then
            player.mo.spriteyscale = $ + FRACUNIT/2
        elseif player.mo.spriteyscale > value.GOALY then
            player.mo.spriteyscale = value.GOALY
        end
    end

    --[[if amplifymode then
        player.normalspeed = skins[player.mo.skin].normalspeed * 3
        player.runspeed = skins[player.mo.skin].runspeed * 3
        player.actionspd = skins[player.mo.skin].actionspd * 3
        player.thrustfactor = skins[player.mo.skin].thrustfactor * 3
        player.mindash = FRACUNIT * 80
        player.maxdash = skins[player.mo.skin].maxdash * 2
    else
        player.normalspeed = (skins[player.mo.skin].normalspeed * 2) + (skins[player.mo.skin].normalspeed / 4)
        player.runspeed = (skins[player.mo.skin].runspeed * 2) + (skins[player.mo.skin].runspeed / 3)
        player.actionspd = skins[player.mo.skin].actionspd * 2
        player.thrustfactor = (skins[player.mo.skin].thrustfactor * 2) + (skins[player.mo.skin].thrustfactor / 3)
    end]]

    if tonumber(CV_FindVar("tkkAmplify").value) then
        player.kartspeed = value.Defaultkartspeed * 4
        player.kartweight = value.Defaultkartweight / 2 + value.Defaultkartweight / 3
    else
        player.kartspeed = value.Defaultkartspeed * 3 - (value.Defaultkartspeed / 2)
        --player.kartweight = value.Defaultkartweight -- weight is unaffected
    end
end,
endfunc = function(player, selfid, value)
    player.kartspeed = value.Defaultkartspeed
    player.kartweight = value.Defaultkartweight
    player.khaos.RestoreSpriteXScaleDown = true
    player.khaos.RestoreSpriteYScaleDown = true
    --player.height = skins[player.mo.skin].height
    --player.mo.spriteyscale = FRACUNIT
end}

  addEffect{name = "Remove Random Effect", chance = FRACUNIT/21, duration = 0, sprite = "KH_TRASH", effect = "neutral", fxrequired = 2, nobees = true,
description = "Does what it says on the tin.",
func = function(player, selfid, value)
    local RANDNUMB = P_RandomRange(1, #player.khaoseffects)

    for index2, value2 in ipairs(player.khaoseffects) do --inception
        if index2 != selfid and index2 == RANDNUMB and not value2.notimerand and not value2.immune2remove and value2.name != "Roulette" and value2.name != "Remove Random Effect" then
            value2.timer = value2.duration*TICRATE + 5
            value.fxdone = true
            break
        end
    end
end}

  addEffect{name = "Invert Controls", chance = FRACUNIT/35, duration = 8, range = 5, sprite = "KH_INVERT", effect = "bad", amplifyonly = true,
description = "Amplify Mode exclusive effect, this does what it says on the tin. Have fun getting used to the normal controls after it goes away!",
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible = {"I WAS FROZEN TODAY!", "Laggy Controls", "Busted Controller", "Drifting"},
func = function(player, sselfid, value)
    player.khaos.InvertControlsNow = true
end,
endfunc= function(player, sselfid, value)
    player.khaos.InvertControlsNow = false
end}

  addEffect{name = "Moonjump", chance = FRACUNIT/15, effect = "neutral", duration = 9, range = 4, sprite = "KH_MOON", addition = 2, nocart = true, nonights = true, nobot = true,
startsfx = sfx_kc5a, endsfx = sfx_kc65, localsfx = true,
description = "Hold the button combo to raise yourself in the air!",
incompatible = {"Cement Tires", "Super Jump", "No Abilities", "Zero Gravity", "Pancake"},
func = function(player, sselfid, value)
    if not value.started then
        value.started = true
        addHUDText(player, "Hold \"Use Item\" & \"Brake\" to levitate!", true)
    end

    if player.cmd.buttons & BT_ATTACK and player.cmd.buttons & BT_BRAKE then
        player.mo.momz = 5*FRACUNIT
    end
end}

  addEffect{name = "Firework", chance = FRACUNIT/28, effect = "neutral", duration = 1, sprite = "KH_FIREWORK", addition = 1, nocart = true, nospawn = true, requirerings = true,
startsfx = sfx_chadet, forcestart = true,
incompatible = {"Cement Tires", "Super Jump", "Zero Gravity"},
description = "Shoots you really far into the sky! There's a chance the fireworks will be explosive.",
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        value.explosive = false
        local amnt = FRACUNIT/2-FRACUNIT/5
        if tonumber(CV_FindVar("tkkAmplify").value) then
            amnt = FRACUNIT/2+FRACUNIT/3
        end
        --[[if IsMatchMode() then
            amnt = $ / 2
        end]]
        if P_RandomChance(amnt) then
            value.explosive = true
        end
    end

    local additioner = FRACUNIT + (FRACUNIT/2) + (FRACUNIT/4)

    --[[if (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) then
        additioner = $ * 20
    end]]

    if not player.respawn.state then
        if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
            player.mo.momz = $ - additioner
        else
            player.mo.momz = $ + additioner
        end
    end

    local function SpawnSpark(x, y, z, state)
        local Sperk = P_SpawnMobj(player.mo.x + x*2, player.mo.y + y*3, player.mo.z + z/4, MT_SIGNSPARKLE)
        Sperk.scale = player.mo.scale
        Sperk.momx = x * 2
        Sperk.momy = y * 2
        Sperk.momz = z * 10
        if state then
            Sperk.state = state
            Sperk.scale = $ / 2
        end
    end

    for i=6,1,-1 do
        SpawnSpark(P_RandomFixed(), P_RandomFixed(), P_RandomFixed())
        if value.explosive then
            SpawnSpark(P_RandomFixed(), P_RandomFixed(), P_RandomFixed(), S_SPINDUST_FIRE1)
        end
    end
end,
endfunc = function(player, selfid, value)
    --S_StartSound(player.mo, sfx_kc65, player)

    local function SpawnSpark(x, y, z, state) --gotta do this twice now :pensive:
        local Sperk = P_SpawnMobj(player.mo.x + x*2, player.mo.y + y*3, player.mo.z + z/4, MT_SIGNSPARKLE)
        Sperk.scale = player.mo.scale
        Sperk.momx = x * 2
        Sperk.momy = y * 2
        Sperk.momz = z * 10
        if state then
            Sperk.state = state
            Sperk.scale = $ / 2
        end
    end

    for i=69,1,-1 do -- nice
        SpawnSpark(P_RandomFixed()*4, P_RandomFixed()*5, P_RandomFixed()*6)
    end

    if value.explosive then
        local explode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_TNTBARREL)
        explode.state = S_TNTBARREL_EXPL1
    end
end
}

  addEffect{name = "Bouncy Floors", chance = FRACUNIT/37, duration = 4, range = 2, effect = "bad", sprite = "KH_BOUNCE", addition = 2, nocart = true, nonights = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible = {"Super Jump", "Gravity Coil", "Cement Tires", "Butter Physics", "Zero Gravity"},
description = "The floors don't like you, and keep bouncing you back up! Don't fast fall on this, otherwise you'll get even less control.",
func = function(player, selfid, value)
    if not value.started then
        player.mo.momz = 3*FRACUNIT
        player.mo.z = $+ 5*FRACUNIT
        value.LastMomZ = player.mo.momz
        value.started = true
    end

    if player.mo.momz/FRACUNIT == 0 then
        if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
            if value.LastMomZ > 0 then
                value.BounceTime = true
            end
        else
            if value.LastMomZ < 0 then
                value.BounceTime = true
            end
        end
    else
        value.LastMomZ = player.mo.momz
    end

    if value.LastMomZ < FRACUNIT and P_IsObjectOnGround(player.mo) then
        value.LastMomZ = $ + 5*FRACUNIT
    end

    value.BounceTime = true

    if value.BounceTime then
        if P_IsObjectOnGround(player.mo) then
            player.mo.momz = abs(value.LastMomZ)
            if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
                player.mo.momz = -$
            end
            S_StartSoundAtVolume(player.mo, sfx_kc52, 150)
            value.BounceTime = false
        end
    end
end}


  addEffect{name = "Windy Day", chance = FRACUNIT/24, duration = 6, range = 3, sprite = "KH_WIND", addition = 3, effect = "bad", nonights = true, nocart = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
description = "A mighty gust is blowing you every which way! You're blown in a certain direction, which changes every now and then to blow you a different way.",
func = function(player, selfid, value)
    if not value.started then
        S_StartSound(player.mo, sfx_s3kcel, player)
        value.angle = player.mo.angle-ANGLE_180
        value.changeang = 0
        value.thrust = FRACUNIT/2 - FRACUNIT/8
        value.posneg = false -- honestly i have no fucking clue what this does. what drugs were you on, 2020-or-so jasmine?
        value.started = true
    end


    if value.changeang > 0 then
        if value.posneg then
            value.angle = $ - (ANG2 + ANG1)
        else
            value.angle = $ + ANG2 + ANG1
        end
        value.changeang = $ - 1
        value.thrust = P_RandomRange(FRACUNIT/2 - FRACUNIT/8, FRACUNIT/2 - FRACUNIT/4) + P_RandomFixed()/4
        if tonumber(CV_FindVar("tkkAmplify").value) then
            value.thrust = $ + P_RandomFixed()/2
        end
    else
        value.changeang = 0
        value.posneg = not value.posneg
        if P_RandomChance(FRACUNIT/5) then
            value.changeang = P_RandomRange(5, 25)
            if tonumber(CV_FindVar("tkkAmplify").value) then
                value.changeang = $ + 2
            end
            --DebugPrint(player, "Changing Angle!")
        end
    end

    P_Thrust(player.mo, value.angle, value.thrust)
end}

  addEffect{name = "Zero Gravity", chance = FRACUNIT/26, effect = "bad", duration = 5, range = 2, sprite = "KH_ZEROGRAV", addition = 3, nocart = true, nonights = true, resetvalues = true,
startsfx = sfx_s3k9c, endsfx = sfx_kc65, localsfx = true,
incompatible = {"Cement Tires", "Super Jump", "Moonjump", "Bouncy Floors"},
description = "Your gravity has been turned off! Often results in you being catapulted to the sky.",
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        value.laststoredmom = player.mo.momz
    end

    if not player.respawn.state then
        if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
            if value.laststoredmom < player.mo.momz then
                player.mo.momz = value.laststoredmom
            end
        else
            if value.laststoredmom > player.mo.momz then
                player.mo.momz = value.laststoredmom
            end
        end
    end

    value.laststoredmom = player.mo.momz
end}

addEffect{name = "Timebomb", chance = FRACUNIT/31, duration = 3, addition = -1, sprite = "KH_BOMB", effect = "bad",
startsfx = sfx_s3k5c,
description = "\x83\"Somebody set us up the bomb!\"\x80 You have a few seconds to react to the fact you're gonna explode! Applies the same explosion as falling for a Land Mine.",
func = function(player, selfid, value)
    if not value.started then
        value.repeatsound = 1
        value.subtracttime = 8
        value.sublimetime = 3
        value.defaulttimer = value.duration*TICRATE - value.timer
        value.started = true
    end

    local function SpawnSplode(x, y, z)
        local theobj = MT_SONIC3KBOSSEXPLODE
        if P_RandomChance(FRACUNIT/5) then
            theobj = MT_BOSSEXPLODE
        end
        local Sperk = P_SpawnMobj(player.mo.x + x*2, player.mo.y + y*3, player.mo.z + z/4, theobj)
        Sperk.scale = player.mo.scale
        Sperk.momx = x * 2
        Sperk.momy = y * 2
        Sperk.momz = z * 5
    end

    local function Blinker()
        if not value.back then
            player.mo.colorized = true
            value.prevcolor = player.mo.color
            player.mo.color = SKINCOLOR_RED
            value.back = true
        else
            player.mo.colorized = false
            player.mo.color = value.prevcolor
            value.back = false
        end
    end

    SpawnSplode(P_RandomFixed()*2, P_RandomFixed()*3, P_RandomFixed()*2)

    if value.defaulttimer > (value.duration*TICRATE - value.timer) - value.repeatsound then -- beeping
        value.repeatsound = $ - value.subtracttime
        value.sublimetime = $ - 1
        if value.sublimetime <= 0 then
            value.sublimetime = 3
            value.subtracttime = $ - 1
        end
        S_StartSound(player.mo, sfx_deton) --sfx_kc2a
        Blinker()
    end

    if value.duration*TICRATE - value.timer == TICRATE/2 + TICRATE/3 then
        S_StartSound(player.mo, sfx_s3k86)
    end
end,
endfunc = function(player,selfid, value)
    local JankSplosion = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SSMINE)
    JankSplosion.target = player.mo
    P_KillMobj(JankSplosion)
    S_StartSound(player.mo, sfx_s3k4e)
    player.mo.color = value.prevcolor
end}

  addEffect{name = "the ride never ends", chance = FRACUNIT/20, duration = 15, range = 8, sprite = "KH_THERIDE", addition = 4, effect = "bad", nonights = true, --nospawn = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
description = "\x83\"I want to get off TAILS WILD RIDE\"\x80 Your screen's perspective gets angled! It gets worse in Amplify Mode.",
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        local RANDYSPIN = P_RandomChance(FRACUNIT/2)
        if not RANDYSPIN then
            player.khaos.SpinOtherWay = true
        else
            player.khaos.SpinOtherWay = false
        end
        value.angler = (ANG30 + ANG15)
        if tonumber(CV_FindVar("tkkAmplify").value) then
            value.angler = (ANG30 + ANG30)
        end
    end
    if not player.khaos.SpinOtherWay then
        if player.viewrollangle < value.angler then
            player.viewrollangle = $ + (ANG1/5)
            player.mo.rollangle = $ - (ANG1/5)
        end
    else
        if player.viewrollangle > -value.angler then
            player.viewrollangle = $ - (ANG1/5)
            player.mo.rollangle = $ + (ANG1/5)
        end
    end
end,
endfunc = function(player, selfid, value)
    player.khaos.RestoreViewAngle = true
end}

  addEffect{name = "Pancake", chance = FRACUNIT/10, duration = 8, range = 5, sprite = "KH_PANCAKE", addition = 7, effect = "bad", nonights = true, nocart = true,
startsfx = sfx_chcake, endsfx = sfx_kc65, forcestart = true,
description = "You get squashed like a pancake, and your max speed gets halved.",
incompatible = {"Cement Tires", "Sticky Slopes", "Black Hole", "Moonjump", "Super Jump", "HE"},
func=function(player, selfid, value)
    if not value.started then
        value.started = true
        value.GOALY = FRACUNIT/4 + FRACUNIT/20
        value.Defaultkartspeed = player.kartspeed
        value.Defaultkartweight = player.kartweight
        if tonumber(CV_FindVar("tkkAmplify").value) then
            value.GOALY = FRACUNIT/6 + FRACUNIT/9 -- nice
        end
        player.khaos.RestoreSpriteXScaleUp = nil
        player.khaos.RestoreSpriteYScaleUp = nil
        player.khaos.RestoreSpriteXScaleDown = nil
        player.khaos.RestoreSpriteYScaleDown = nil
    end

    player.mo.spritexscale = FRACUNIT + FRACUNIT

    if player.mo.spriteyscale != value.GOALY then
        if player.mo.spriteyscale > value.GOALY then
            player.mo.spriteyscale = $ - FRACUNIT/2
        elseif player.mo.spriteyscale < value.GOALY then
            player.mo.spriteyscale = value.GOALY
        end
    end

    if tonumber(CV_FindVar("tkkAmplify").value) then
        player.kartspeed = value.Defaultkartspeed / 2 - value.Defaultkartspeed / 6 --  33%
        player.kartweight = value.Defaultkartweight / 2 + value.Defaultkartweight / 4
    else
        player.kartspeed = value.Defaultkartspeed / 2 --50%
        player.kartweight = value.Defaultkartweight / 2 + value.Defaultkartweight / 8
    end
end,
endfunc=function(player, selfid, value)
    player.kartspeed = value.Defaultkartspeed
    player.kartweight = value.Defaultkartweight
    player.khaos.RestoreSpriteYScaleUp = true
    player.mo.spritexscale = FRACUNIT
end}


  addEffect{name = "Cement Tires", chance = FRACUNIT/21, duration = 7, range = 4, sprite = "KH_CEMENTTIRE", addition = 1, nocart = true, effect = "bad", nonights = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
description = "Your tires have been filled with cement! Your max speed gets reduced to 20%.",
incompatible = {"HE", "Pancake", "Sticky Slopes", "I WAS FROZEN TODAY!", "Change Color", "No Abilities", "Butter Physics", "Black Hole", "Bouncy Floors", "Gravity Coil", "Super Jump", "Moonjump", "Zero Gravity"}, -- so many items
func = function(player, selfid, value)
    if not value.started then
        value.started = true
        --value.CementPrevColor = player.mo.color
        value.Defaultkartspeed = player.kartspeed
        value.Defaultkartweight = player.kartweight
    end
    if tonumber(CV_FindVar("tkkAmplify").value) then
        player.kartspeed = value.Defaultkartspeed / 5 -- 20%
        player.kartweight = value.Defaultkartweight * 4
    else
        player.kartspeed = value.Defaultkartspeed / 4 -- 25%
        player.kartweight = value.Defaultkartweight * 3
    end

    -- P_SetObjectMomZ(player.mo, -gravity, true)

    if (player.mo.eflags & MFE_VERTICALFLIP) or (player.mo.flags2 & MF2_OBJECTFLIP) then
        if player.mo.momz > 0 then
            player.mo.momz = $ + $ / 10
        else
            player.mo.momz = $ - $ / 8
        end
    else
        if player.mo.momz > 0 then
            player.mo.momz = $ - $ / 10
        else
            player.mo.momz = $ + $ / 8
        end
    end

    if not P_IsObjectOnGround(player.mo) then
        player.khaos.CementShoesSfx = true
        if player.mo.momz < -(3*FRACUNIT) and not player.khaos.CementShoesFallSfx then
            S_StartSound(player.mo, sfx_s3k51, player)
            player.khaos.CementShoesFallSfx = true
        end
    else
        if player.khaos.CementShoesSfx then
            S_StartSound(player.mo, sfx_s3k5f) --previously sfx_pstop, and before that, sfx_doord2
            P_StartQuake(15, 10*FRACUNIT, 10*FRACUNIT, player.mo)
            player.khaos.CementShoesSfx = false
        end
        player.khaos.CementShoesFallSfx = false

        value.angle = player.mo.angle - ANGLE_180
        value.thrust = player.speed / 50

        P_Thrust(player.mo, value.angle, value.thrust)
    end
end,
endfunc = function(player,selfid, value)
    player.kartspeed = value.Defaultkartspeed
    player.kartweight = value.Defaultkartweight
    --player.kartstuff[k_boostpower] = 0
    --player.mo.color = value.CementPrevColor
    --player.mo.colorized = false
end}

  addEffect{name = "Butter Physics", chance = FRACUNIT/28, duration = 8, range = 6, sprite = "KH_BUTTER", addition = 2, effect = "neutral",
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible = {"Cement Tires", "Sticky Slopes"},
description = "Forget ice physics, your tires have been slathered with butter. You are completely unstoppable. You might go zooming across the entire track... or keep falling into pits. Or both.",
func = function(player, selfid, value)
    player.mo.friction = FRACUNIT + (FRACUNIT/80)
end,
endfunc = function(player,selfid, value)
    player.mo.friction = player.khaos.OGFriction
end}

  addEffect{name = "Fling Player", chance = FRACUNIT/10, duration = 0, sprite = "KH_PLACEHOLDER", nocart = true, nohudtext = true, effect = "bad", nonights = true,
incompatible = {"I WAS FROZEN TODAY!"},
description = "You get tossed around, either forward or backwards. If you get slapped or yeeted, you also spin out!",
func=function(player, selfid, value)
    local RANDYSLAP
    local RANDYYEET = P_RandomChance(FRACUNIT/20) -- 5%
    local Angler = player.mo.angle + (P_RandomRange(0, 4) * ANGLE_90)
    if tonumber(CV_FindVar("tkkAmplify").value) then
        P_InstaThrust(player.mo, Angler, 170*FRACUNIT)
        if P_IsObjectOnGround(player.mo) then RANDYSLAP = P_RandomChance(FRACUNIT/3) end -- 33.3%, reduced chances since spinout causes you to lose control
    else
        P_InstaThrust(player.mo, Angler, 80*FRACUNIT)
        if P_IsObjectOnGround(player.mo) then RANDYSLAP = P_RandomChance(FRACUNIT/2 + FRACUNIT/6) end -- 66.6%
    end
    if RANDYSLAP or RANDYYEET then
        if RANDYYEET then
            addHUDText(player, "YEET", true)
            local yeetsfx = sfx_chyee2
            if P_RandomChance(FRACUNIT/2) then
                yeetsfx = sfx_chyeet
            end
            S_StartSound(player.mo, yeetsfx)
            S_StartSound(player.mo, sfx_kc5b, player)
        else
            addHUDText(player, "Slapped!")
            S_StartSound(player.mo, sfx_slappy)
        end
        --[[player.spinouttype = KSPIN_WIPEOUT
        player.spinouttimer = TICRATE
        player.mo.state = S_KART_SPINOUT]]
        K_TumblePlayer(player)
        --player.powers[pw_flashing] = TICRATE
        if tonumber(CV_FindVar("tkkAmplify").value) then
            player.mo.momz = $ + 12*FRACUNIT
        else
            player.mo.momz = $ + 5*FRACUNIT
        end
    else
        addHUDText(player, "Fling Player")
        S_StartSound(player.mo, sfx_s3k81)
        player.mo.momz = $ + 2*FRACUNIT
    end
    value.fxdone = true
end
}

  addEffect{name = "Change Character", chance = FRACUNIT/26, duration = 3, range = 2, sprite = "KH_CHARS", effect = "neutral", endsfx = sfx_kc65, forceend = true,
incompatible = {"I WAS FROZEN TODAY!", "Change Color"},
description = "Changes your current character repeatedly until the effect expires. This can't pick any characters you haven't unlocked yet!",
func = function(player, selfid, value)
    if not value.started then
        local RANDYC = P_RandomRange(-5, TICRATE-(TICRATE)/2) -- approximately 17 tics, or half a second
        value.timer = $ - RANDYC
        value.skinzor = skins[1].name --iniitialize it to something so we don't get an error
        value.started = true
    end
    if (leveltime % 5 == 0) then
        S_StartSoundAtVolume(player.mo, sfx_kc56, 136)
        repeat
            value.skinzor = skins[P_RandomRange(1, #skins-1)].name
        until value.skinzor and R_SkinUsable(player, value.skinzor) -- have to check skinzor actually exists for some reason
        R_SetPlayerSkin(player, value.skinzor)
    end
end,
endfunc = function(player, selfid, value)
    if not value.freeze then
        local dust = P_SpawnMobj(player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)),
        player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.z, MT_DUST)
        dust.scale = FRACUNIT*2
        dust.state = S_XPLD1
        addHUDText(player, "Character changed to: " .. skins[player.mo.skin].realname)
    end
end
}

  addEffect{name = "Change Color", chance = FRACUNIT/13, duration = 3, range = 2, sprite = "KH_COLORS", effect = "neutral", nomatch = true, endsfx = sfx_kc65, forceend = true,
incompatible = {"I WAS FROZEN TODAY!", "Cement Tires", "Change Character"},
description = "This changes your current character's color until the timer expires.",
func = function(player, selfid, value)
    if (leveltime % 4 == 0) then
        player.mo.color = P_RandomRange(1, #skincolors-1)
        S_StartSoundAtVolume(player.mo, sfx_kc56, 136)
        player.skincolor = player.mo.color
    end
end,
endfunc = function(player,selfid, value)
    if not value.freeze then
        local dust = P_SpawnMobj(player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)),
        player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, FixedMul(-1*FRACUNIT, player.mo.scale)), player.mo.z, MT_DUST)
        dust.scale = FRACUNIT*2
        dust.state = S_XPLD1
        addHUDText(player, "Color changed to: " .. R_GetNameByColor(player.mo.color))
    end
end
}

  addEffect{name = "Lucky!", chance = FRACUNIT/16, effect = "good", duration = 15, range = 8, sprite = "KH_LUCK", addition = 1,
startsfx = sfx_s1c9, endsfx = sfx_kc65, localsfx = true,
incompatible = {"PANIC", "Overreaction"},
description = "This makes it so most of the time you take a hit, you instead dodge it! You're also more likely to roll good effects than bad. Finally, the time between effects is increased a bit.",
func=function(player, selfid, value)
    player.khaos.IsLucky = true
    if player.khaos.timer > 0 and tonumber(CV_FindVar("tkkAmplify").value) or P_RandomChance(FRACUNIT/4) then -- reduce da timer just a bit
        player.khaos.timer = $ - 1
    end
end,
endfunc = function(player)
    player.khaos.IsLucky = false
end
}

  addEffect{name = "PANIC", chance = FRACUNIT/30, effect = "bad", duration = 14, range = 6, sprite = "KH_PANIC", addition = 3,
startsfx = sfx_alarm, endsfx = sfx_kc65, localsfx = true,
incompatible = {"Lucky!"},
description = "Effects get applied to you alarmingly quick! You're also more likely to roll bad effects!",
func=function(player, selfid, value)
    player.khaos.timer = $ + 1
    player.khaos.IsPanicking = true
    if tonumber(CV_FindVar("tkkAmplify").value) or P_RandomChance(FRACUNIT/14) then -- do it even m o r e
        player.khaos.timer = $ + 2
    end
end,
endfunc = function(player)
    player.khaos.IsPanicking = false
end
}

  addEffect{name = "Kids These Days", chance = FRACUNIT/34, duration = 11, range = 4, sprite = "KH_PLACEHOLDER", effect = "bad", addition = 5, nobot = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible={"Darkened Vision", "DVD Screensaver"},
description = "\x83\"Back in my day...\"\x80 The sides of your screen are obscured!",
func=function(player,selfid,value)
    player.khaos.ipadkid = true
end,

endfunc=function(player,selfid,value)
   player.khaos.ipadkid = false
end}

  addEffect{name = "Darkened Vision", chance = FRACUNIT/23, duration = 15, range = 5, sprite = "KH_DARKV", effect = "bad", addition = 5, nobot = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible={"Kids These Days"},
description="\x83\"Ya bring a light? No!\"\x80 Your vision is significantly darkened!",
func=function(player,selfid,value)
    player.khaos.DarkenedVisionNow = true
end,

endfunc=function(player,selfid,value)
    player.khaos.DarkenedVisionNow = false
end}

  addEffect{name = "YOU'RE WINNER", chance = FRACUNIT/18, duration = 18, range = 7, sprite = "KH_WINNER", effect = "bad", addition = 5, nobot = true,
startsfx = sfx_ideya, endsfx = sfx_kc65, localsfx = true, --sfx_xideya?
incompatible={"Kids These Days"},
description="You win! Congratulations! Wait, you didn't? Well, you'll get showered in confetti anyways.",
func=function(player,selfid,value)
    player.khaos.yourewinner = true
end,

endfunc=function(player,selfid,value)
    player.khaos.yourewinner = false
end}

  addEffect{name = "Overreaction", chance = FRACUNIT/36, duration = 25, range = 5, sprite = "KH_REACT", effect = "bad", addition = 5, nobot = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible={"Super Explosive 64", "Lucky!", "Nuke"},
description="Every hit you take will make you tumble instead! There's also a chance you just get stunlocked for a little bit, watch out!",
func=function(player,selfid,value)
    player.khaos.Overreacting = true
    if (leveltime % 6) == 0 then
        player.khaos.Tumbler = $ - 2
    end
end,

endfunc=function(player,selfid,value)
    player.khaos.Overreacting = false
    player.khaos.Tumbler = 0
end}

  addEffect{name = "Invisible", chance = FRACUNIT/26, effect = "neutral", duration = 10, range = 5, sprite = "KH_NOTHING", addition = 3, resetvalues = true, --invisibleblink = true,
startsfx = sfx_kc65, endsfx = sfx_kc65, forcestart = true,
incompatible = {"Ghost", "Change Sprite", "Laggy Model"},
description="\x83\"I'm the invisible man.\"\x80 You can't see yourself, but also, neither can anyone else.",
func=function(player,selfid,value)
    player.khaos.InvisibleNow = true
end,

endfunc=function(player,selfid,value)
    player.khaos.InvisibleNow = false
end}

  addEffect{name = "DVD Screensaver", chance = FRACUNIT/27, duration = 12, range = 8, sprite = "KH_DVD", effect = "bad", addition = 5, nobot = true,
startsfx = sfx_kc59, endsfx = sfx_kc65, localsfx = true,
incompatible={"Kids These Days"}, -- how fitting
description="Your screen has the DVD logo bouncing around! This hinders vision a lot.",
func=function(player,selfid,value)
    if not value.started then
        value.started = true
        local RANDY = P_RandomChance(FRACUNIT/8) -- pretty rare chance, just like how rare HD DVDs are to come across in the real world
        if RANDY then
            player.khaos.HDDVD = true
        end
    end

    player.khaos.DVDHud = true
end,

endfunc=function(player,selfid,value)
    player.khaos.DVDHud = false
    player.khaos.HDDVD = false
end}


  addEffect{name = "Always Watching.", chance = FRACUNIT/18, duration = 18, range = 15, sprite = "KH_EYE", effect = "neutral",
startsfx = sfx_s3k8a, endsfx = sfx_kc65,
incompatible = {"I WAS FROZEN TODAY!", "Invisible"},
description="Your character is turned around 180 degrees, to face you. They know what you did last night.",
func=function(player,selfid, value)
    player.drawangle = player.mo.angle + ANGLE_180
end}

addEffect{name = "Superring", chance = FRACUNIT/15, duration = 0, effect = "good", sprite = "KH_RING", startsfx = sfx_itemup, nobattle = true,
description="Gives you 10 rings! 20 rings in Amplify Mode.",
func=function(player,selfid, value)
    if tonumber(CV_FindVar("tkkAmplify").value) then
        --P_GivePlayerRings(player, 20)
        player.superring = $ + 20
    else
        --P_GivePlayerRings(player, 10)
        player.superring = $ + 10
    end
    value.fxdone = true
end}

addEffect{name = "Anti-Superring", chance = FRACUNIT/18, duration = 0, effect = "bad", sprite = "KH_ANTIRING", noboss = true, startsfx = sfx_antiri, nobattle = true,
description="Takes away 10 rings! It takes away 20 rings in Amplify Mode, instantly putting you into ring debt.",
func=function(player,selfid, value)
    if tonumber(CV_FindVar("tkkAmplify").value) then
        P_GivePlayerRings(player, -20) -- devastating
    else
        P_GivePlayerRings(player, -10)
    end
    value.fxdone = true
end}


addEffect{name = "Double Items", dontrollme = true, chance = 1, nohudtext = true, duration = -1, effect = "good", nobees = true, immune2remove = true, dontcountme = true,
description="This is an invisible effect that gets stored after \"You Get The Bees\" grants everyone Double Items. This will make it so the next item you pick up gives you, well, double items! It's quadruple items in Amplify Mode.",
func=function(player,selfid, value) -- shut up this technically works
    if player.itemamount > 0 then
        player.itemamount = $ * 2
        if tonumber(CV_FindVar("tkkAmplify").value) then
            player.itemamount = $ * 2 -- quadruple
        end
        value.fxdone = true
    else
        value.timer = 0
    end
end
}

  addEffect{name = "COMBO TIME!", chance = FRACUNIT/19, duration = 0, effect = "neutral", sprite = "KH_PANIC", notimer = true,
description="This applies two effect roulettes at the same time!",
startsfx = sfx_kc48,
func=function(player, selfid, value)
    ApplyEffect(player, "Roulette")
    ApplyEffect(player, "Roulette")
    value.fxdone = true
end}

  addEffect{name = "Roulette", chance = 1, duration = -1, sprite = "KH_PLACEHOLDER", nohudtext = true, notimer = true, dontrollme = true, noblink = true, dontcountme = true,
description = "This is the Khaos Roulette, the most evil creation Tails has made. This rolls for effects, and depending on the chance to roll the effect, it will apply said effect to the current driver. Various conditions will stop effects from being applied however, just to tone back the chaos a smidge bit.",
func=function(player, selfid, value)
    if not value.started then
        value.VRoller = P_RandomRange(1, #KhaosEffectsTable-1)
        value.started = true
    end

    value.VRoller = $ + 1

    if value.VRoller > #KhaosEffectsTable then
        value.VRoller = 1
    end

    local evalue = KhaosEffectsTable[value.VRoller]

   if player.khaosoptions.tkkHUDPosition then
        value.ytime = $ + 2
        if value.ytime > value.ymax then
            value.ytime = value.ymax
        end
    else
        value.ytime = $ - 2
        if value.ytime < value.ymax then
            value.ytime = value.ymax
        end
    end

    if player.khaosoptions.tkkRouletteSFX and player.khaosoptions.tkkHUD then
        S_StartSoundAtVolume(player.mo, sfx_cdfm46, 80, player) -- tink sound that plays when rolling an effect
    end
    value.icon = evalue.sprite
    local ChanceTime = evalue.chance
    if player.khaos.IsLucky then
        if evalue.effect == "bad" then
            ChanceTime = $ - ($/4)
        elseif evalue.effect == "good" then
            ChanceTime = $ + ($/3)
        end
    elseif player.khaos.IsPanicking then
        if evalue.effect == "bad" then
            ChanceTime = $ + ($/5)
        elseif evalue.effect == "good" then
           ChanceTime = $ - ($/5)
        end
    end

    if value.timer > TICRATE and not value.freeze and not evalue.dontrollme and P_RandomChance(ChanceTime) and CheckNonConflict(player, value.VRoller) then
        ApplyEffect(player, evalue.name)
        value.fxdone = true
    end
end
}

addHook("PlayerSpawn", function(player)
    if not player.khaos then
        player.khaos = {}
        player.khaosmemory = {}
        player.khaoseffects = {}
        player.khaostext = {}
    end

    if not player.khaosoptions then -- keep seperate to not have this reset on map change
        player.khaosoptions = {}
        player.khaos.OptionDelay = 3*TICRATE
        for key, value in pairs(optionstableofdoom) do
            if not value.localonly then
                local TheGame = value.name --you lost it
                local TheMame = CV_FindVar(TheGame).defaultvalue
                if value.typer == "number" then
                    TheMame = tonumber($)
                end
                player.khaosoptions[TheGame] = TheMame
            end
        end
    else
        player.khaos.OptionDelay = -1
        player.khaos.OptionsTextConfirm = true
        player.khaos.OptionsLoaded = true
    end

    player.khaos.timer = 0
    player.khaos.WaitTime = 0
    player.khaos.failsafetimer = 0
    player.khaos.addHUDTextRando = 0
    player.khaos.HUDMoveUp = 0
    player.khaos.TextPopUpTimer = 0
    player.khaos.TextPopUpFade = 0
    if not tkkEnabled then
        player.khaos.TextPopUpTimer = 6969
        player.khaos.TextPopUpFade = 6969
    end
    player.khaos.UniPopUpTimer = 0
    player.khaos.UniEffectSubTextBuffer = ""
    player.khaos.UniEffectTextBuffer = ""
    player.khaos.UniEffecTextBufferNumber = 1
    player.khaos.UniTextPopUpFade = 0
    player.khaos.TextBoxAdvancePage = 0
    player.khaos.TextBoxFader = 0
    player.khaos.Tumbler = 0

    player.khaos.RewindX = player.mo.x
    player.khaos.RewindY = player.mo.y
    player.khaos.RewindZ = player.mo.z
    player.khaos.RewindAngle = player.mo.angle

    player.khaos.InvertControlsNow = nil
    player.khaos.BorkedSteering = nil

    if not player.khaos.OGFriction then
        player.khaos.OGFriction = player.mo.friction
    end

end)

--[[addHook("ThinkFrame", function()
    if (leveltime % TICRATE == 0) then
        --print("hi")
        --print(KhaosEffectsTable[1])
        --print(KhaosEffectsTable[1].name)
    end
end)]]

addHook("PlayerCmd", function(player, ticcmd)
    if not player.khaos then return end
    if player.khaos.BorkedSteering then
        ticcmd.turning = $ + player.khaos.BorkedSteering
    end
    if player.khaos.InvertControlsNow then
        ticcmd.turning = -$
    end
end)

addHook("PreThinkFrame", function()
    for player in players.iterate do
        if ValidityCheck(player) then
            if player.khaos.FrozenNow then
                if (tonumber(player.khaos.postturning) != tonumber(player.cmd.turning))
                and player.khaos.FrozenWait == 0 then
                    player.khaos.FrozenShake = true -- isn't that just a slushie?
                end
                player.khaos.postturning = player.cmd.turning
            end
        end
    end
end)

addHook("PostThinkFrame", function()
    for player in players.iterate do
        if ValidityCheck(player) then
            if player.khaos.GhostNow then  -- thanks to Faye on the SRB2 discord for discovering how to get MF2_SHADOW working
                player.mo.renderflags = $ | RF_SHADOWDRAW
            end
            if player.khaos.GhostBegone then
                player.mo.renderflags = $ & ~RF_SHADOWDRAW
                player.khaos.GhostBegone = false
            end

            if player.khaos.InvisibleNow then
                player.mo.renderflags = $ | RF_DONTDRAW
            end

            if player.khaos.InvisibleBegone then
                player.mo.renderflags = $ & ~RF_DONTDRAW
                player.khaos.InvisibleBegone = false
            end

            if player.khaos.FrozenNow and not player.khaos.ChangeSpriteNow and player.khaos.FrozenState and not player.respawn.state then
                player.mo.state = player.khaos.FrozenState
                player.mo.frame = player.khaos.FrozenFrame
                player.nocontrol = 1
                if player.followmobj
                and player.khaos.FollowFrozenState and player.khaos.FollowFrozenFrame then -- redundancy beacuse script errord during testing for some unknown reason
                    player.followmobj.state = player.khaos.FollowFrozenState
                    player.followmobj.frame = player.khaos.FollowFrozenFrame
                end
            end

            if player.khaos.FrozenShake and player.khaos.FrozenWait > 2 then
                player.mo.spritexoffset = P_RandomRange(-5, 5) * FRACUNIT
                player.mo.spriteyoffset = P_RandomRange(-5, 5) * FRACUNIT
            end
        end
    end
end)

addHook("PlayerThink", function(player)
    if not ValidityCheck(player) return end -- if turning playerthink into a thinkframe hook, be sure to change this around too

    --[[if player.respawn.state
        print("RESPAWNING")
    end]]

    if player.khaos.OptionDelay > -5 then
        player.khaos.OptionDelay = $ - 1
    end

    if player.khaos.OptionDelay <= 0 and not player.khaos.OptionsLoaded then
        if not player.bot then
            LoadSettings(player)
        else -- player is bot, don't try to load anything
            player.khaos.OptionsLoaded = true
        end
    end

    if player.khaos.OptionsLoaded and not player.khaos.OptionsTextConfirm and player.khaos.OptionDelay <= -4 then -- need to wait just a little bit for the slow-ass command to actually change the load failed value
        if player.khaos.LoadFailed then
            addHUDText(player, "\x85" + "Error loading options! Check the console & luafiles folder.", true, 4)
            S_StartSound(player.mo, sfx_adderr, player)
        else
            addHUDText(player, "\199" + "Loaded options!", true)
            S_StartSound(player.mo, sfx_gshc4, player) --sfx_tmxsuc
            S_StartSound(player.mo, sfx_gshc4, player)
            S_StartSound(player.mo, sfx_gshc4, player)
        end
        player.khaos.OptionsTextConfirm = true
    end

    local Freezer = false

    --TODO: investigate if leveltime >= starttime works
    if leveltime < 6*TICRATE or player.exiting or player.playerstate == PST_DEAD or player.laps > numlaps then -- freeze all effects if the level is finished, or if the player Fucking Dies
        Freezer = true
    end

    player.khaos.Freezer = Freezer

    if player.khaos.WaitTime == 0 then
        player.khaos.WaitTime = P_RandomRange(TICRATE*3, TICRATE*10) -- TODO: replace with "minwait" and "maxwait" settings
        if player.khaos.IsLucky then
            player.khaos.WaitTime = $ + P_RandomRange(0, TICRATE) -- adds an extra second if lucky
        end
    end

    if not Freezer then
        player.khaos.timer = $ + 1
    end

    if (player.khaos.timer > player.khaos.WaitTime) then --activate roulette
        ApplyEffect(player, "Roulette")
        player.khaos.timer = 0
        player.khaos.WaitTime = 0
    end

    if CV_FindVar("tkkDebug").value then --TODO: comment out this debug tool before playtest!
        if (player.cmd.buttons & BT_LUAA) then
            --K_SpinPlayer(player, nil, nil, KSPIN_THRUST)
            --K_DoInstashield(player)
            --K_TumblePlayer(player)
            --P_DamageMobj(player.mo, nil, nil, 1, DMG_DEATHPIT)
            --DMG_DEATHPIT
            --P_DamageMobj(player.mo, nil, nil, 1, DMG_DEATHPIT)
            --P_KillMobj(player.mo)
            if not player.khaos.holdabutton then
                player.spinouttype = KSPIN_IFRAMES
                player.flashing = 76
                player.superring = $ + 10
            end
            player.khaos.holdabutton = true
        else
            player.khaos.holdabutton = false
        end

        if (player.cmd.buttons & BT_LUAB) then
            local Gay = "Hey! Listen!"
            if not player.khaos.holddebugbutton and CheckNonConflict(player, indexOfName(KhaosEffectsTable, Gay), 3) then
                ApplyEffect(player, Gay)
            end
            player.khaos.holddebugbutton = true
        else
            player.khaos.holddebugbutton = false
        end


        if (player.cmd.buttons & BT_LUAC) then
            local Gay = "Moonjump"
            if not player.khaos.hold3rdbutton then
                for p2 in players.iterate do
                    if ValidityCheck(player) then
                        ApplyEffect(p2, Gay)
                    end
                end
            end
            player.khaos.hold3rdbutton = true
        else
            player.khaos.hold3rdbutton = false
        end
    end

    --[[if player.cmd.buttons & BT_DRIFT and player.cmd.buttons & BT_BRAKE and player.cmd.buttons & BT_ACCELERATE and player.cmd.buttons & BT_ATTACK
        print(players[0].khaosoptions.tkkMemory)
    end]]

    if player.respawn.state then
        player.khaos.failsafetimer = $ + 1
    else
        player.khaos.failsafetimer = 0
    end

    -- [[ -- Effect Logic -- ]] --
    for index, value in ipairs(player.khaoseffects) do
        local effecter = KhaosEffectsTable[value.effect]

        if effecter.func and not Freezer then
            effecter.func(player, index, value)
            if not player.respawn.state or player.khaos.failsafetimer > 5*TICRATE then -- don't decrease timer during respawn, unless the player's been respawning for > 5 seconds
                value.timer = $ + 1
            end
            if player.khaos.failsafetimer > 9*TICRATE then -- player seems to be taking awfully long to respawn, double the timer speeds to get rid of effects quick
                value.timer = $ + 1
            end
        end

        if player.respawn.state and effecter.restartrespawn then
            value.started = false
        end

        if (value.duration > 0 and (value.timer > value.duration*TICRATE)) or value.fxdone then
            DebugPrint(player, "REMOVING: " + effecter.name)
            if effecter.endfunc then
                effecter.endfunc(player, index, value)
            end
            if player.khaosoptions.tkkHUD or effecter.forceend then
                if effecter.endsfx then
                    if value.localsfx then
                        S_StartSound(player.mo, effecter.endsfx, player)
                    else
                        S_StartSound(player.mo, effecter.endsfx)
                    end
                end
            end
            table.remove(player.khaoseffects, index)
        end
    end

    -- Rewind --

    if (leveltime % (3*TICRATE)) == 0 then --every 2 seconds is a lot more generous
        --print("set new position")
        player.khaos.RewindX = player.mo.x
        player.khaos.RewindY = player.mo.y
        player.khaos.RewindZ = player.mo.z
        player.khaos.RewindAngle = player.mo.angle
    end

    -- Restore angle'd view --
    if player.khaos.RestoreViewAngle then
        if player.khaos.SpinOtherWay then
            if player.viewrollangle < 0
                player.viewrollangle = $ + (ANG10/4)
                player.mo.rollangle = $ - (ANG10/4)
            else
                player.viewrollangle = 0
                player.mo.rollangle = 0
                player.khaos.RestoreViewAngle = false
                player.khaos.SpinOtherWay = false
            end
        else
            if player.viewrollangle > 0 then
                player.viewrollangle = $ - (ANG10/4)
                player.mo.rollangle = $ + (ANG10/4)
            else
                player.viewrollangle = 0
                player.mo.rollangle = 0
                player.khaos.RestoreViewAngle = false
            end
        end
    end

    -- Restore Sprite Stuff --
    if player.khaos.RestoreSpriteYScaleUp then
        if player.mo.spriteyscale < FRACUNIT then
            player.mo.spriteyscale = $ + FRACUNIT/10
        elseif player.mo.spriteyscale >= FRACUNIT then
            player.mo.spriteyscale = FRACUNIT
            player.khaos.RestoreSpriteYScaleUp = false
        end
    end

    if player.khaos.RestoreSpriteXScaleDown then
        if player.mo.spritexscale > FRACUNIT then
            player.mo.spritexscale = $ - FRACUNIT/10
        elseif player.mo.spritexscale <= FRACUNIT then
            player.mo.spritexscale = FRACUNIT
            player.khaos.RestoreSpriteXScaleDown = false
        end
    end

    if player.khaos.RestoreSpriteYScaleDown then
        if player.mo.spriteyscale > FRACUNIT then
            player.mo.spriteyscale = $ - FRACUNIT/10
        elseif player.mo.spriteyscale <= FRACUNIT then
            player.mo.spriteyscale = FRACUNIT
            player.khaos.RestoreSpriteYScaleDown = false
        end
    end

    -- [[ -- HUD Logic -- ]] --

    player.khaos.TextPopUpTimer = $ + 1
    if (player.khaos.TextPopUpTimer > 5*TICRATE and (((player.khaos.TextPopUpTimer-2*TICRATE)*2) % 5 == 0)) then
        player.khaos.TextPopUpFade = $ + 1
    end

    if player.khaos.TextPopUpTimer > 10*TICRATE
        player.khaos.respawnmeinchief = true
    end

    if player.khaos.HUDMoveUp > 0 then
        player.khaos.HUDMoveUp = $ - 2
    end

    if player.khaos.HUDMoveUp < 0 or #player.khaostext == 0 then -- the latter shouldn't happen, but who knows if the screen gets flooded with text
        player.khaos.HUDMoveUp = 0
    end

    if player.khaos.addHUDTextRando > 0 then
        player.khaos.addHUDTextRando = $ - 1
    end

    for index, value in ipairs(player.khaostext) do
        -- starting position, then add 10 for each value
        value.timer = $ + 1

        if (value.expire - value.timer) > 1*TICRATE then
            value.flags = 0
        else
            if (((value.timer-2*TICRATE)*2) % 5 == 0) then
                value.trans = $ + 1
            end
            value.flags = value.trans<<V_ALPHASHIFT
        end

        if value.timer > value.expire then
            table.remove(player.khaostext, index)
            player.khaos.HUDMoveUp = $ + 9
        end
    end

    -- [[ -- Universal Effect Player HUD Logic -- ]] --

    player.khaos.ueTimer = ueTimer -- for the hud
    player.khaos.ueTimerMax = ueTimerMax
    if initiateUE then
        player.khaos.ueTimer = 0 -- just to make it look smooth when an effect is being rolled
    end

    if player.khaos.UniEffectText
        local MaxLength = #player.khaos.UniEffectText
        local SubMaxLength = 0
        if player.khaos.UniEffectSubText then
            SubMaxLength = #player.khaos.UniEffectSubText
        end

        if player.khaos.UniPopUpTimer % 1 == 0 then -- every one tic. used to be two but i'm leaving this here so it's easier to revert this if i want to
            player.khaos.UniEffecTextBufferNumber = $ + 1
        end

        player.khaos.UniEffectTextBuffer = string.sub(player.khaos.UniEffectText, 1, min(player.khaos.UniEffecTextBufferNumber, MaxLength))
        if player.khaos.UniEffectSubText then
            player.khaos.UniEffectSubTextBuffer = string.sub(player.khaos.UniEffectSubText, 1, min(player.khaos.UniEffecTextBufferNumber, SubMaxLength))
        end

        player.khaos.UniPopUpTimer = $ + 1
        if (player.khaos.UniPopUpTimer > 5*TICRATE and (((player.khaos.UniPopUpTimer-2*TICRATE)*2) % 5 == 0)) then
            player.khaos.UniTextPopUpFade = $ + 1
        end

        if player.khaos.UniPopUpTimer > 8*TICRATE
            player.khaos.UniPopUpTimer = 0
            player.khaos.UniTextPopUpFade = 0
            player.khaos.UniEffecTextBufferNumber = 1
            player.khaos.UniEffectText = nil
            player.khaos.UniEffectSubText = nil
            player.khaos.UniEffectSubTextBuffer = ""
            player.khaos.UniEffectTextBuffer = ""
        end
    end


end)


local UniversalEffectsTable = {}
local PreviousUniversalEffect = "" -- done to prevent the same effect from being applied again

local function addUniversalEffect(tbl)
    table.insert(UniversalEffectsTable, tbl)
end

-- addEffect{name = "TEST!", chance = FRACUNIT/99, effect = "good", duration = 10, sprite = "KH_PLACEHOLDER", addition = 1, func = TestFunc}

local RunFunc = nil

addUniversalEffect{name = "\199" + "\201" +"Supersonic Racing", subtext = {"Try to keep your tires right on the ground!", "There's no time to look around!", "Come on, let the fire burn!"},
sounds = {sfx_cssrac, sfx_cssra2}, microsounds = {sfx_mssrac, sfx_mssra2}, chance = FRACUNIT/32, func = function()
    for player in players.iterate do
        if ValidityCheck(player) then
            player.invincibilitytimer = $ + 8*TICRATE
            local TwilightSparkle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_INVULNFLASH)
            TwilightSparkle.target = player.mo
            TwilightSparkle.destscale = player.mo.scale
            P_SetScale(TwilightSparkle, player.mo.scale)
        end
    end
    RunFunc = nil
end
}

addUniversalEffect{name = "Insta-item", subtext = {"FOR FREE?", "It's free real estate.", "But what if I already have an item :(", "Please don't give me BAR again."}, --TODO: give player a hidden khaos effect for this instead.
sounds = {sfx_cinsit, sfx_cinsi2}, microsounds = {sfx_minsit, sfx_minsi2}, chance = FRACUNIT/18, func = function()
    for player in players.iterate do
        if ValidityCheck(player) then
            if not player.khaos.ItsFreakingFluttershy then
                player.lastpickupdistance = 0 -- in v2.3 of ring racers, this doesn't do anything. this should hopefully be fixed by an MR i made though!
                player.khaos.ItsFreakingFluttershy = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_RANDOMITEM) -- might as well continue the MLP:FiM reference. it's freaking fluttershy
                player.khaos.ItsFreakingFluttershy.flags2 = $ | MF2_DONTRESPAWN -- just double insurance to make sure it doesn't respawn, or if it deleting somehow fails, that after pickup it goes away
                player.khaos.ItsFreakingFluttershy.target = player.mo
                if gametype != GT_BATTLE and P_RandomChance(FRACUNIT - FRACUNIT/4) then -- 75% chance for item, 25% chance for rings
                    player.khaos.ItsFreakingFluttershy.state = S_RANDOMITEM1
                    --[[if gametype == GT_BATTLE then -- i don't think this works for some reason, so it's disabled for the playtest. TODO: fix this after playtest lol
                        player.khaos.ItsFreakingFluttershy.state = S_SPHEREBOX1
                    end]]
                end
                player.khaos.FlutterTimer = 0
            end
            player.khaos.FlutterTimer = $ + 1
            if player.khaos.FlutterTimer >= 2 then
                if player.khaos.ItsFreakingFluttershy and player.khaos.ItsFreakingFluttershy.valid then
                    P_KillMobj(player.khaos.ItsFreakingFluttershy)
                    player.khaos.ItsFreakingFluttershy = nil
                end
                player.khaos.FlutterTimer = nil
            end
        end
    end
    RunFunc = nil
end
}

addUniversalEffect{name = "You Get The Bees", subtext = {"Rolling effect..."},
sounds = {sfx_cbees, sfx_cbees2}, microsounds = {sfx_mbees, sfx_mbees2}, chance = FRACUNIT/13, func = function()
    local RanEffect = false
    local StatusEffect = nil
    local StatusRand = 1
    repeat
        StatusRand = P_RandomRange(1, #KhaosEffectsTable)
        StatusEffect = KhaosEffectsTable[StatusRand]
        if P_RandomChance(StatusEffect.chance) and not StatusEffect.nobees and GlobalNonConflict(StatusRand)
        and ((not StatusEffect.nobot) or (StatusEffect.nobot and botcount-1 < playercount/2)) -- don't roll nobot effects if half the server is bots.
        then
            RanEffect = true
        else
            return
        end
    until RanEffect

    if RanEffect then -- just for in case the loop somehow breaks early
        for player in players.iterate do
            if ValidityCheck(player) then
                if CheckNonConflict(player, StatusRand, 1) and not player.khaos.Freezer then
                    ApplyEffect(player, StatusEffect.name)
                else
                    ApplyEffect(player, "Bee Storage", {storeeffect = StatusRand, icon = StatusEffect.sprite})
                end
                player.khaos.UniEffectSubText = "\x82" + "Bees give everyone"+ "\x80:" + StatusEffect.name
                player.khaos.UniEffecTextBufferNumber = 0
            end
        end
        RunFunc = nil
    end
end
}

addUniversalEffect{name = "Double Items", amplifyname = "Quadruple Items", subtext = {"Don't got one? Don't worry, it'll apply next time.", "Gee Bill, how come mom let's you get TWO items?"},
amplifysubtext = {"Don't got one? Don't worry, it'll apply next time.", "Gee Bill, how come mom let's you get FOUR items?"},
sounds = {sfx_cditem, sfx_cdite2}, amplifysounds = {sfx_cquadi, sfx_cquad2}, microsounds = {sfx_mditem, sfx_mdite2}, microamplifysounds = {sfx_mquadi, sfx_mquad2}, -- the price of having silly ideas
chance = FRACUNIT/19, func = function()
    for player in players.iterate do
        if ValidityCheck(player) then
            ApplyEffect(player, "Double Items")
        end
    end
    RunFunc = nil
end
}

  addUniversalEffect{name = "Wacky Textures", subtext = {"why are the walls screaming?", "Using AI, you too can make maps this beautiful!", "You forgot to install Counter-Strike: Source.", "i made you a sneaker panel, but i eated it", "i will force you to touch grass"},
sounds = {sfx_cwacky, sfx_cwack2}, microsounds = {sfx_mwacky, sfx_mwack2}, chance = FRACUNIT/101, func = function()
    local TheTables = {{"KH_BUP", "DEV_GA1", "BLUFLAT", "FINISH_W", "~113", "RINDRA00", "BPZFLD01", "BPZFLD04", "FFZGRSS2", "DVBR1C", "JPPI01", "SPWALG1"},
    {"KH_BUP"},
    --{"FINISH_W"}
    }

    local ListOfWacky = TheTables[P_RandomRange(1, #TheTables)]

    for sector in sectors.iterate do
        if sector.floorpic != "F_SKY1" then
            sector.floorpic = ListOfWacky[P_RandomRange(1, #ListOfWacky)]
        end
        if sector.ceilingpic != "F_SKY1" then
            sector.ceilingpic = ListOfWacky[P_RandomRange(1, #ListOfWacky)]
        end
    end

    for line in lines.iterate do
        if line.frontside and line.frontside.toptexture then
            line.frontside.toptexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end
        if line.frontside and line.frontside.midtexture then
            line.frontside.midtexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end
        if line.frontside and line.frontside.bottomtexture then
            line.frontside.bottomtexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end

        if line.backside and line.backside.toptexture then
            line.backside.toptexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end
        if line.backside and line.backside.midtexture then
            line.backside.midtexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end
        if line.backside and line.backside.bottomtexture then
            line.backside.bottomtexture = R_TextureNumForName(ListOfWacky[P_RandomRange(1, #ListOfWacky)])
        end
    end
    RunFunc = nil
end
}

addUniversalEffect{name = "\202" + "Ka-boom!", subtext = {"\x85" + "CRITICAL SYSTEM ERROR 0x074115", "None of you are free from sin.", "Why did you sneeze that loud?", "kart hurting juice :("},
sounds = {sfx_ckabom, sfx_ckabo2}, microsounds = {sfx_mkabom, sfx_mkabo2}, chance = FRACUNIT/64, func = function()
    for player in players.iterate do
        if ValidityCheck(player) then
            player.khaos.UniEffecTextBufferNumber = 9001 -- forcefully sets the text buffer to the end so the text actually shows up
            P_KillMobj(player.mo)
        end
    end
    RunFunc = nil
end
}

addHook("MapChange", function() -- done solely because replays are fucking broken and it requires this
    ueTimer = 0
    ueTimerBuffer = 0
    ueTimerMax = tonumber(CV_FindVar("tkkUniversalTimer").value) * TICRATE
    tkkEnabled = tonumber(CV_FindVar("tkkEnabled").value)
    initiateUE = false
    RunFunc = nil
    PreviousUniversalEffect = ""
    for player in players.iterate do
        player.khaos = nil
        player.khaosmemory = nil
        player.khaoseffects = nil
        player.khaostext = nil
    end
end)


-- gametype == GT_BATTLE

addHook("PostThinkFrame", function()
    for player in players.iterate do
        if ValidityCheck(player) then
            if player.khaos.GhostNow then  -- thanks to Faye on the SRB2 discord for discovering how to get MF2_SHADOW working
                player.mo.renderflags = $ | RF_SHADOWDRAW
            end
            if player.khaos.GhostBegone then
                player.mo.renderflags = $ & ~RF_SHADOWDRAW
                player.khaos.GhostBegone = false
            end

            if player.khaos.InvisibleNow then
                player.mo.renderflags = $ | RF_DONTDRAW
            end

            if player.khaos.InvisibleBegone then
                player.mo.renderflags = $ & ~RF_DONTDRAW
                player.khaos.InvisibleBegone = false
            end
        end
    end
end)

local prevtkkAmplify = 0
local prevtkkEnabled = 1

addHook("ThinkFrame", function()
    if (leveltime % TICRATE == 0) then -- don't spam it, it might cause unnessecary lag to check every tic
        ueTimerMax = tonumber(CV_FindVar("tkkUniversalTimer").value) * TICRATE

        if prevtkkAmplify != tonumber(CV_FindVar("tkkAmplify").value) then
            prevtkkAmplify = tonumber(CV_FindVar("tkkAmplify").value)
            local Texter = "\x85" + "Amplify Mode" + "\x80" + " is now "
            local Sounder = sfx_tmxsuc
            if prevtkkAmplify == 0 then
                Texter = $ + "\x82" + "deactivated."
            else
                Texter = "\202" + $ + "\x82" + "activated!!!"
                Sounder = sfx_gshd9
            end
            for player in players.iterate do
                if ValidityCheck(player) then
                    addHUDText(player, Texter, true)
                    S_StartSound(player.mo, Sounder, player)
                end
            end
        end
        if prevtkkEnabled != tonumber(CV_FindVar("tkkEnabled").value) then
            prevtkkEnabled = tonumber(CV_FindVar("tkkEnabled").value)
            local Texter = "\x82" + "Tails' Khaos Kontraption" + "\x80" + " will be "
            local Sounder = sfx_tmxsuc
            if prevtkkEnabled == 0 then
                Texter = $ + "\x85" + "deactivated "
            else
                Texter = $ + "\x83" + "activated "
            end
            Texter = $ + "\x80" + "next round."
            chatprint("* " + Texter)
            for player in players.iterate do
                CONS_Printf(player, Texter)
                S_StartSound(player.mo, Sounder, player)
                if ValidityCheck(player) then
                    addHUDText(player, Texter, true)
                end
            end
        end
        botcount = 0
        hasanyonefinished = false
        for player in players.iterate do
            playercount = $ + 1
            if player.bot then
                botcount = $ + 1
            end
            if player.laps > numlaps then
                --print("SOMEONE FINISHED")
                hasanyonefinished = true
            end
        end
    end

    if not playercount then return end -- no players exist! assume this is the title screen.

    -- Universal Effects --
    if not tonumber(CV_FindVar("tkkUniversalFxEnabled").value) or hasanyonefinished then TailsKK.ueTimerDisabled = true return end -- don't run if the option is disabled!
    ueTimer = $ + 1
    TailsKK.ueTimerDisabled = false

    if ueTimer > ueTimerMax and not initiateUE and not RunFunc then -- don't run if RunFunc is still going! hopefully the script didn't break lol
        S_StartSoundAtVolume(nil, sfx_gshd2, 255) -- sfx_kc33, sfx_kc4b, sfx_kc5e, sfx_mbv85, sfx_kc47
        S_StartSoundAtVolume(nil, sfx_gshd2, 255) -- sfx_kc33, sfx_kc4b, sfx_kc5e, sfx_mbv85, sfx_kc47
        for player in players.iterate do
            if ValidityCheck(player)
                if player.laps <= numlaps then
                    player.khaos.UniEffectText = "Rolling Universal Effect..."
                    -- reset everything just to make sure that the text actually shows up if the timer is set to be way too short somehow
                    player.khaos.UniPopUpTimer = 0
                    player.khaos.UniTextPopUpFade = 0
                    player.khaos.UniEffecTextBufferNumber = 1
                    player.khaos.UniEffectSubText = nil
                    player.khaos.UniEffectSubTextBuffer = ""
                end
            end
        end
        initiateUE = true
        ueTimer = 0
    end

    if initiateUE then
        local StatusRand = P_RandomRange(1, #UniversalEffectsTable)
        local StatusEffect = UniversalEffectsTable[StatusRand]

        if StatusEffect then -- sfx_s3kd2s
            if ueTimerBuffer > TICRATE then -- only apply after a second passes, should give enough time to plonk in the text
                if P_RandomChance(StatusEffect.chance) and StatusEffect.name != PreviousUniversalEffect then
                    initiateUE = false
                    RunFunc = StatusRand

                    for player in players.iterate do
                        if ValidityCheck(player) then
                            local TheSnable = StatusEffect.sounds
                            if player.khaosoptions.tkkUniversalAnnouncer then
                                TheSnable = StatusEffect.microsounds
                            end
                            if tonumber(CV_FindVar("tkkAmplify").value) and StatusEffect.amplifysounds then
                                TheSnable = StatusEffect.amplifysounds
                                if player.khaosoptions.tkkUniversalAnnouncer then
                                    TheSnable = StatusEffect.microamplifysounds
                                end
                            end
                            local TheSound = TheSnable[1]
                            if #TheSnable > 1 then
                                TheSound = TheSnable[P_RandomRange(1, #TheSnable)]
                            end

                            S_StartSoundAtVolume(nil, TheSound, 255, player) -- do it 4 times because sounds are quiet for no good reason
                            S_StartSoundAtVolume(nil, TheSound, 255, player)
                            S_StartSoundAtVolume(nil, TheSound, 255, player)
                            S_StartSoundAtVolume(nil, TheSound, 255, player)

                            player.khaos.UniEffectText = StatusEffect.name

                            if tonumber(CV_FindVar("tkkAmplify").value) and StatusEffect.amplifyname then
                                player.khaos.UniEffectText = StatusEffect.amplifyname
                            end
                            if StatusEffect.subtext then
                                local TheGlable = StatusEffect.subtext
                                if tonumber(CV_FindVar("tkkAmplify").value) and StatusEffect.amplifysubtext then
                                    TheGlable = StatusEffect.amplifysubtext
                                end
                                player.khaos.UniEffectSubText = TheGlable[1]
                                if #TheGlable > 1 then
                                    local TheChosenOne = P_RandomRange(1, #TheGlable)
                                    player.khaos.UniEffectSubText = TheGlable[TheChosenOne]
                                end
                            else -- force clear
                                player.khaos.UniEffectSubText = ""
                            end
                            player.khaos.UniPopUpTimer = 0
                            player.khaos.UniTextPopUpFade = 0
                            player.khaos.UniEffecTextBufferNumber = 1
                        end
                    end
                    if (replayplayback) then -- replay..ers can't hear the universal sound, so we force it. idfk what to do about spectators if they can't hear it tho, sorry
                        local TheSnable = StatusEffect.sounds
                        if tonumber(CV_FindVar("tkkUniversalAnnouncer").value) then
                            TheSnable = StatusEffect.microsounds
                        end
                        local TheSound = TheSnable[1]
                        S_StartSoundAtVolume(nil, TheSound, 255) -- do it 4 times because sounds are quiet for no good reason
                        S_StartSoundAtVolume(nil, TheSound, 255)
                        S_StartSoundAtVolume(nil, TheSound, 255)
                        S_StartSoundAtVolume(nil, TheSound, 255)
                    end
                    PreviousUniversalEffect = StatusEffect.name
                    ueTimerBuffer = 0
                end
            else
                ueTimerBuffer = $ + 1
                ueTimer = 0 -- reset timer, just to be sure.
                return -- not sure what this is doing here actually. i think it's to stop runfunc from going ahead?
            end
        end
    end

    if RunFunc then
        UniversalEffectsTable[RunFunc].func()
    end
end)

addHook("MobjThinker", function(aggressive) -- this code is directly lifted from my MMT script, i have no shame
    if aggressive.valid and aggressive.target and aggressive.target.valid then
        if not aggressive.initializedtime then
            aggressive.shadowscale = 3*FRACUNIT
            if aggressive.sizeoption == "large" then
                aggressive.speed = 20*FRACUNIT
                aggressive.scale = FRACUNIT + FRACUNIT*(2/4)
            elseif aggressive.sizeoption == "medium" then
                aggressive.speed = 20*FRACUNIT
                aggressive.scale = FRACUNIT
            elseif (aggressive.sizeoption == "small" or aggressive.sizeoption == "personal") then
                aggressive.speed = (22*3)*FRACUNIT
                aggressive.scale = FRACUNIT/4
            elseif (aggressive.sizeoption == "xl" or aggressive.sizeoption == "extra large" or aggressive.sizeoption == "extralarge") then
                aggressive.speed = 49*FRACUNIT
                aggressive.scale = FRACUNIT*2
            else
                aggressive.speed = (36*2)*FRACUNIT
                aggressive.scale = FRACUNIT/2
            end
            aggressive.ogspeed = aggressive.speed
            aggressive.initializedtime = true
        end
        if not aggressive.rollanglesprite then
            aggressive.rollanglesprite = 0
        end
        aggressive.rollanglesprite = $ + ANG15

        if aggressive.state != S_CHAOTICPIZZAFACE then
            aggressive.rollangle = aggressive.rollanglesprite
        end

        if aggressive.target.player.respawn.state or aggressive.target.player.playerstate != PST_LIVE then --slow down if the player is respawning or dead
            aggressive.speed = aggressive.ogspeed / 10
        else
            aggressive.speed = aggressive.ogspeed
        end

        if (R_PointToDist2(aggressive.target.x, aggressive.target.y, aggressive.x, aggressive.y))/FRACUNIT < 35 and
        (abs((aggressive.target.z - aggressive.z)/FRACUNIT) < 25) and (aggressive.target.player and aggressive.target.player.playerstate == PST_LIVE)
        and not aggressive.Remove
        and not aggressive.target.player.respawn.state then
            P_DamageMobj(aggressive.target, aggressive, aggressive, DMG_SPIKE)

            S_StartSound(aggressive.target, sfx_chapki)
            if aggressive.state == S_CHAOTICXPLOSPIZZA then
                local Explode = P_SpawnMobj(aggressive.target.x, aggressive.target.y, aggressive.target.z, MT_BOSSEXPLODE)
                S_StartSound(explode, sfx_bkpoof)
                Explode.destscale = 3*FRACUNIT
                Explode.scalespeed = FRACUNIT/7
            end
            aggressive.target.player.khaos.PizzaHitTarget = true
            aggressive.Remove = true
        end

        if aggressive.target and not aggressive.target.player.khaos.PizzaRemoval then
            A_HomingChase(aggressive, aggressive.speed, 0)
        else
            P_RemoveMobj(aggressive)
        end
    else
        P_RemoveMobj(aggressive)
    end
end, MT_JIMBO)

addHook("MobjThinker", function(cs)
    if cs.despawn then P_RemoveMobj(cs) return end
    if not cs.gayer then P_RemoveMobj(cs) return end
    if not cs.gayer.valid then P_RemoveMobj(cs) return end
    if cs.gayer.RemoveChangeSprite then P_RemoveMobj(cs) return end
    local player = cs.gayer

    -- replicate a lot of player stuff here
    P_MoveOrigin(cs, player.mo.x, player.mo.y, player.mo.z)
    cs.shadowscale = FRACUNIT
    cs.scale = player.mo.scale
    cs.color = player.mo.color
    cs.spritexoffset = player.mo.spritexoffset
    cs.spriteyoffset = player.mo.spriteyoffset
    cs.spritexscale = player.mo.spritexscale
    cs.spriteyscale = player.mo.spriteyscale
    cs.angle = player.drawangle or player.mo.angle
    --cs.rollangle = player.mo.rollangle -- doesn't work?
    --cs.flags = player.mo.flags
    cs.flags2 = player.mo.flags2 & MF2_OBJECTFLIP
    cs.renderflags = player.mo.renderflags & RF_SHADOWDRAW
    --cs.eflags = player.mo.eflags
    if cs.Blinker then
        cs.renderflags = $ | RF_DONTDRAW
    else
        cs.renderflags = $ & ~RF_DONTDRAW
    end

    if cs.summonedasstate == S_CHAOTICPIZZA then
        cs.rollangle = $ + ANG15
    end

    if cs.summonedasstate == S_SOSS_RUN1 then -- summoned ass tate
        if player.speed/FRACUNIT == 0 then
            cs.tics = -1
        else
            if cs.tics == -1 then
                cs.tics = 1
            end
            if player.speed-2*FRACUNIT >= 10*FRACUNIT and cs.tics == 3 then
                cs.tics = 2
            end
        end
    elseif (cs.summonedasstate == S_YHORIZ1 or cs.summonedasstate == S_YELLOWSPRING1) then
        if abs(player.mo.momz) > 0 and not cs.sprung then
            if cs.summonedasstate == S_YHORIZ1 then
                cs.state = S_YHORIZ2
            else
                cs.state = S_YELLOWSPRING2
            end
            cs.sprung = true
        end
    end

    if P_IsObjectOnGround(player.mo) then
        cs.sprung = false
    end

end, MT_CHANGESPRITE)

addHook("MobjThinker", function(mo)
    if mo.despawn then P_RemoveMobj(cs) return end
    if not mo.gayer then P_RemoveMobj(cs) return end
    if not mo.gayer.valid then P_RemoveMobj(cs) return end

    local player = mo.gayer
    if not mo.initialized then
        --P_MoveOrigin(mo, player.mo.x, player.mo.y, player.mo.z)
        mo.skin = player.mo.skin
        mo.state = player.mo.state
        mo.sprite2 = player.mo.sprite2
        --mo.sprite = player.mo.sprite
        mo.color = player.mo.color
        mo.angle = player.mo.angle
        mo.scale = player.mo.scale
        mo.spritexoffset = player.mo.spritexoffset
        mo.spriteyoffset = player.mo.spriteyoffset
        mo.colorized = player.mo.colorized
        --mo.flags = player.mo.flags
        --mo.flags2 = player.mo.flags2
        mo.eflags = player.mo.eflags
        mo.rollangle = player.mo.rollangle
        mo.initialized = true
    end

end, MT_LAGPLAYER)

addHook("MobjDamage", function(mo)
    local player = mo.player
    if not player then return end
    if not player.khaos then return end -- just in case
    if (not player.flashing or player.khaos.DodgeHit) and ((player.khaos.IsLucky and P_RandomChance(FRACUNIT/2 + FRACUNIT/8)) or player.khaos.DodgeHit) then -- not P_PlayerInPain(player) and
        player.spinouttype = KSPIN_IFRAMES -- required to have player.flashing not get immediately reset to 0
        player.flashing = 76
        if not player.khaos.DodgeHit and player.khaos.IsLucky then
            S_StartSound(player.mo, sfx_s3k7a)
            addHUDText(player, "Dodged a hit, lucky!", true)
        end
        return true -- by returning, we override the rest of mobjdamage's functions, ergo no damage
    end
    if player.khaos.Overreacting then
        player.khaos.Tumbler = $ + 1
        if player.khaos.Tumbler < 15 -- stops the player from being whacked too much... hopefully.
            K_TumblePlayer(player)
        end
    end
end, MT_PLAYER)

local function SanityCheck(var1, var2) -- this is here to prevent players from loading invalid settings
    local var1place = false
    for index, value in ipairs(optionstableofdoom) do
        if var1 == value.name then
            var1place = index
        end
    end

    if var1place then
        local snable = optionstableofdoom[var1place]
        if snable.localonly then return false end -- don't load local variables. TODO: allow this to be loaded by admins?
        if (snable.typer == "number" and tonumber(var2) != nil) and (tonumber(var2) >= snable.values[1] and tonumber(var2) <= snable.values[2]) then
            return true
        end
        if snable.typer == "string" then
            local var2exists = false
            for key, value in pairs(snable.values) do
                if value == var2 then
                    var2exists = true
                end
            end
            return var2exists
        end
    end

    return false
end

local function numbercunktion(player, var1, var2)
    if var1 == nil or var2 == nil or not SanityCheck(var1, var2) then
        CONS_Printf(player, "\x85" + "* INVALID SETTINGS: \x80" .. tostring(var1) .. ", " .. tostring(var2))
        if player and player.khaos then player.khaos.LoadFailed = true end
        return
    end

    if player and player.khaosoptions then player.khaosoptions[var1] = tonumber(var2) end
end

local function stringcunktion(player, var1, var2)
    if var1 == nil or var2 == nil or not SanityCheck(var1, var2) then
        CONS_Printf(player, "\x85" + "* INVALID SETTINGS: \x80" .. tostring(var1) .. ", " .. tostring(var2))
        if player and player.khaos then player.khaos.LoadFailed = true end
        return
    end

    if player and player.khaosoptions then player.khaosoptions[var1] = tostring(var2) end
end

COM_AddCommand("zkhaosDONOTUSEMEPLEASE1", numbercunktion, COM_NOSHOWHELP)
COM_AddCommand("zkhaosDONOTUSEMEPLEASE2", stringcunktion, COM_NOSHOWHELP)

COM_AddCommand("tkkLoadSettings", LoadSettings)
COM_AddCommand("tkkSaveSettings", SaveSettings)
COM_AddCommand("tkkAttributions", function(player)
    for key, value in pairs(TailsKK.attributions) do
        CONS_Printf(player, "* \x82"+value[1]+"\x80: "+value[2])
    end
end)

local function TheNumberFeeder(var)
    if consoleplayer then -- stops this thing from bitching in the logs
        COM_BufInsertText(consoleplayer, "zkhaosDONOTUSEMEPLEASE1 " + var.name + " " + var.value)
        --CONS_Printf(consoleplayer, "zkhaosDONOTUSEMEPLEASE1 " + var.name + " " + var.value)
    end
end

local function TheStringFeeder(var)
    if consoleplayer then
        COM_BufInsertText(consoleplayer, "zkhaosDONOTUSEMEPLEASE2 " + var.name + " " + var.value)
        --CONS_Printf(consoleplayer, "zkhaosDONOTUSEMEPLEASE2 " + var.name + " " + var.value)
    end
end

COM_AddCommand("tkkListEffects", function(player) --if it exceeds 70 characters, line break
    local TableMan = {}
    local StringLength = 0
    local TableInd = 1
    for index, value in ipairs(KhaosEffectsTable) do
        local comma = "\x80, "
        if index == 1 then
           comma = ""
        end
        local Phrase = "\x82" + value.name + comma
        local ThisLength = string.len(Phrase)
        if StringLength + ThisLength > 70 then
            StringLength = 0
            TableInd = $ + 1
        end
        TableMan[TableInd] = (TableMan[TableInd] and Phrase + $) or (Phrase)
        StringLength = $ + ThisLength
    end
    CONS_Printf(player, "* \x83" + "List of Khaos Effects:")
    for i = #TableMan, 1, -1 do
        CONS_Printf(player, "\x81" + TableMan[i])
    end
end)

COM_AddCommand("tkkWhatIs", function(player, var1)
    local effecter = var1 and indexOfName2(KhaosEffectsTable, var1)
    if not effecter then
        CONS_Printf(player, "* \x85"+"Invalid effect name!\x80" + "Be sure to use \"quotation marks\"! Use \"tkkListEffects\" to show all effect names.")
        return
    else
        effecter = KhaosEffectsTable[effecter]
    end
    local description = ""

    if effecter.description then
        description = effecter.description
    else
        description = "Sorry, this effect doesn't have a description yet!"
    end

    local Color = "\x86"
    if effecter.effect == "good" then
        Color = "\x83"
    elseif effecter.effect == "bad" then
        Color = "\x85"
    end

    CONS_Printf(player, "* "+ Color + effecter.name)
    CONS_Printf(player, "*\x81 Description" + "\x80: " + description)

    local Duration = (effecter.duration < 0 and "Infinite") or (effecter.duration and tostring(effecter.duration) + " second") or "Instant"
    if effecter.duration > 1 then
        Duration = $ + "s"
    end

    if effecter.duration > 0 and effecter.range then
        local mintime = max(effecter.duration - (effecter.range/3), effecter.duration/2 + 1) -- done to prevent effect from going under half it's time
        local maxtime = effecter.duration + (effecter.range + 2)
        Duration = mintime + "-" + maxtime + " seconds"
    end


    CONS_Printf(player, "*\x81 Duration" + "\x80: " + Duration)
end)


--NOTICE: When adding/modifying options, be sure to put it in "optionstableofdoom", otherwise it won't work.

CV_RegisterVar({name = "tkkEnabled", defaultvalue = 1, PossibleValue = CV_OnOff, flags = CV_NETVAR, description = "If disabled, the chaos mod will be turned off on the next map."})
CV_RegisterVar({name = "tkkAmplify", defaultvalue = 0, PossibleValue = CV_OnOff, flags = CV_NETVAR, description = "Makes most effects more intense, often worse."})
CV_RegisterVar({name = "tkkUniversalTimer", defaultvalue = 45, PossibleValue = {MIN = 10, MAX = 100}, flags = CV_NETVAR, description = "Sets the timer for when Universal Effects are rolled for."})
CV_RegisterVar({name = "tkkUniversalFxEnabled", defaultvalue = 1, PossibleValue = CV_OnOff, flags = CV_NETVAR, description = "If disabled, Universal Effects will be disabled."})
CV_RegisterVar({name = "tkkDebug", defaultvalue = 0, PossibleValue = CV_OnOff, flags = CV_NETVAR, description = "Enables debugging features like printing."})

--CV_RegisterVar({name = "tkkBlacklist", defaultvalue = 8, PossibleValue = {MIN = 0, MAX = 14}, func = TheNumberFeeder, flags = CV_CALL, description = "Use in combination with 'ttkBlacklistStore' to never roll for this effect."})
CV_RegisterVar({name = "tkkMemory", defaultvalue = 9, PossibleValue = {MIN = 0, MAX = 14}, func = TheNumberFeeder, flags = CV_CALL, description = "Sets how many effects are remembered to not roll for."})
CV_RegisterVar({name = "tkkUniversalAnnouncer", defaultvalue = 0, PossibleValue = {original = 0, micro = 1}, func = TheNumberFeeder, flags = CV_CALL, description = "Changes the voice of the announcer for Universal Effects, from S.A.M. to MS Sam."})
CV_RegisterVar({name = "tkkPrintEffect", defaultvalue = 1, PossibleValue = CV_OnOff, func = TheNumberFeeder, flags = CV_CALL, description = "Prints to the console when you get an effect applied to you."})
CV_RegisterVar({name = "tkkRouletteSFX", defaultvalue = 1, PossibleValue = CV_OnOff, func = TheNumberFeeder, flags = CV_CALL, description = "Plays little sounds when the roulette is active."})
CV_RegisterVar({name = "tkkHUD", defaultvalue = 1, PossibleValue = CV_OnOff, flags = CV_CALL, func = TheNumberFeeder, description = "If changed, the HUD will be disabled, and most sounds won't play."})
CV_RegisterVar({name = "tkkHUDTimerBar", defaultvalue = 1, PossibleValue = CV_OnOff, flags = CV_CALL, func = TheNumberFeeder, description = "If changed, the visual timer between effects will be disabled."})
CV_RegisterVar({name = "tkkHUDPosition", defaultvalue = 0, PossibleValue = {bottom = 0 , top = 1}, flags = CV_CALL, func = TheNumberFeeder, description = "Changes the position of the effects and timerbar."})
CV_RegisterVar({name = "tkkHUDTextBorder", defaultvalue = 1, PossibleValue = CV_OnOff, flags = CV_CALL, func = TheNumberFeeder, description = "Enables a border around the text on the HUD."})
CV_RegisterVar({name = "tkkHUDOverride", defaultvalue = 0, PossibleValue = CV_OnOff, flags = CV_CALL, func = TheNumberFeeder, description = "When spectating/viewing replays, override the viewed player's settings with your own when viewing them."})
CV_RegisterVar({name = "tkkRainbowTimer", defaultvalue = 0, PossibleValue = CV_OnOff, flags = CV_CALL, func = TheNumberFeeder, description = "Makes the timer bar glow rainbow colors!"})

addHook("NetVars", function(net) -- DO NOT TRY TO USE NETVARS TO SYNC FUNCTIONS. THIS WILL FAIL.
    PreviousUniversalEffect = net(PreviousUniversalEffect)
    RunFunc = net(RunFunc)
    ueTimer = net(ueTimer)
    ueTimerBuffer = net(ueTimerBuffer)
    ueTimerMax = net(ueTimerMax)
    initiateUE = net(initiateUE)
    botcount = net(botcount)
    playercount = net(playercount)
    hasanyonefinished = net(hasanyonefinished)
    tkkEnabled = net(tkkEnabled)

    --UniversalEffectsTable = net(UniversalEffectsTable)
    --KhaosEffectsTable = net(KhaosEffectsTable) -- < NOTICE: DO NOT DO THIS UNDER ANY FUCKING CIRCUMSTANCES.
end)

local KhaosTotal = #KhaosEffectsTable

for key, value in pairs(KhaosEffectsTable) do
    if value.dontcountme then
        KhaosTotal = $ - 1
    end
end

table.insert(TextBoxTable, -- at the bottom just so we get an accurate count of all effects
{{"Did you know? You are",
"playing " + "\x87" + "Tails' Khaos",
"\x87"+ "Kontraption " + "\x81" + TailsKK.version + "\x80" + ",",
"with \x85" + KhaosTotal + "\x80 effects!"},
{"This was rewritten from",
"the ground up in a few",
"weeks! Now you know!",""}}
)

LoadSettings() -- force load the cvars

print("Tails' Khaos Kontraption v" .. TailsKK.version .." loaded! Total number of effects: " .. KhaosTotal .. ", and universal effects: " .. #UniversalEffectsTable)
